'From Squeak 2.0 of May 22, 1998 on 27 September 1998 at 9:59:24 pm'!
Object subclass: #Cache
	instanceVariableNames: 'contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Caches'!
Object subclass: #CachedObjectRaiser
	instanceVariableNames: 'powerCache target '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Algorithms'!
Object subclass: #CollectionProduct
	instanceVariableNames: 'temporal '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Algorithms'!
Tuple subclass: #ColumnTuple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Tuples'!
Object subclass: #GaussianRootFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
GaussianRootFinder class
	instanceVariableNames: 'current '!
Cache subclass: #KeySortingCache
	instanceVariableNames: 'keys '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Caches'!
Object subclass: #Monomial
	instanceVariableNames: 'scalar literal degree '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #NumberInterval
	instanceVariableNames: 'start stop '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Intervals'!
NumberInterval subclass: #ClosedInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Intervals'!
NumberInterval subclass: #ClosedOpenInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Intervals'!
Object subclass: #ObjectRaiser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Algorithms'!
ObjectRaiser subclass: #BetterObjectRaiser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Algorithms'!
NumberInterval subclass: #OpenClosedInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Intervals'!
NumberInterval subclass: #OpenInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Intervals'!
Object subclass: #Polynomial
	instanceVariableNames: 'monomials '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Polynomial subclass: #MVPolynomial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #PowerLiteral
	instanceVariableNames: 'literal degree '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #QuickSearch
	instanceVariableNames: 'target collection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Algorithms'!
Tuple subclass: #RowTuple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Tuples'!
Polynomial subclass: #SVPolynomial
	instanceVariableNames: 'qSearch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #ScalarAmbient
	instanceVariableNames: 'zero identity '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Ambients'!
ScalarAmbient class
	instanceVariableNames: 'current '!
ScalarAmbient subclass: #ScalarAmbientFloats
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Ambients'!
ScalarAmbient subclass: #ScalarAmbientIntegers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Ambients'!
ScalarAmbient subclass: #ScalarAmbientRationals
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Ambients'!
Object subclass: #ScalarRunAmbient
	instanceVariableNames: 'scalarAmbient dim '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Ambients'!
ScalarRunAmbient subclass: #ScalarArrayAmbient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Ambients'!
Object subclass: #SturmChain
	instanceVariableNames: 'chain valueCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #SturmPlotter
	instanceVariableNames: 'plotSize negColors posiColors zeroColor polyChain sampleAmount answer logValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Sturm plotter'!
MorphicWrapper subclass: #SturmPlotterMorph
	instanceVariableNames: 'image lastInterval internalCount intA intB fZero fR '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Sturm plotter'!
Object subclass: #SturmPolyMax
	instanceVariableNames: 'rootFinder poly '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #SturmRootFinder
	instanceVariableNames: 'chain poly rootIntervals '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mathematics-Polynomials'!
Object subclass: #Tuple
	instanceVariableNames: 'contents scalarAmbient '
	classVariableNames: 'DefaultScalarAmbient '
	poolDictionaries: ''
	category: 'Mathematics-LinearAlgebra: Tuples'!
Tuple class
	instanceVariableNames: 'scalarAmbient '!

!Object methodsFor: 'testing' stamp: 'SqR 1/4/98 11:00'!
isMonomial
	"Answer false"

	^false! !

!Object methodsFor: 'testing' stamp: 'SqR 1/4/98 10:21'!
isPowerLiteral
	"Answer false"

	^false! !

!Object methodsFor: 'MorphicWrapper support' stamp: 'r++ 6/14/1998 16:58'!
asMorph
	" public - answer the propper MorphicWrapper (as answered to #morphicWrapperClass) that will represente me in a MorphicWorld"
	^ self morphicWrapperClass on: self!
]style[(8 31 14 17 20 81)f1b,f1,f1LMorphicWrapper Comment;,f1,f1LObject morphicWrapperClass;,f1! !

!Object methodsFor: 'MorphicWrapper support' stamp: 'r++ 6/14/1998 17:24'!
hasMorphicWrapper
	^ (Smalltalk at: #MorphicWrapper) existsWrapperFor: self!
]style[(18 19 14 24)f1b,f1,f1LMorphicWrapper Comment;,f1! !

!Object methodsFor: 'MorphicWrapper support' stamp: 'r++ 6/14/1998 17:00'!
morphicWrapperClass
	" public - provied a default morphicWrapperClass that can represent any object in a WorldMorph"
	^ Smalltalk at: #RoughMorphicWrapper!
]style[(20 30 19 85)f1b,f1,f1LMorphicWrapper Comment;,f1! !

!Object methodsFor: 'MorphicWrapper support' stamp: 'r++ 7/9/1998 18:16'!
updateMorph
	" public - if I do have a MorphicWrapper asociated, it will be updated in response to this message, it's useful to inmediatly reflect my changes if I'm living in a MorphicWorld"
	| myWorld |
	self hasMorphicWrapper ifTrue: [
		(myWorld _ self asMorph updateContents; world)
			ifNotNil: [myWorld displayWorld]]!
]style[(12 27 14 270)f1b,f1,f1LMorphicWrapper Comment;,f1! !


!Cache reorganize!
('Accessing' at: at:ifAbsentEvaluate: at:put: cachedKeys cachedValueFor: forget:)
('Enumerating' forgetAllThat:)
('Testing' hasCachedValueFor:)
('Private-Accessors' contents contents:)
('Private-Initializing' initialize)
!


!Cache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:11'!
at: anObject
	"Answer the cached value for anObject. If no value is cached, answer an error"

	^self contents at: anObject! !

!Cache methodsFor: 'Accessing' stamp: 'SqR!!!! 9/11/1998 23:55'!
at: aKey ifAbsentEvaluate: aBlock
	"Answer the cached value for aKey. If no cached value for aKey is present
	in the receiver, evaluate aBlock, cache its evaluation and answer it"

	^contents at: aKey ifAbsent: [self at: aKey put: aBlock value]! !

!Cache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:11'!
at: anObject put: aValue
	"Set the cached value to anObject. Answer aValue"

	^self contents at: anObject put: aValue! !

!Cache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:26'!
cachedKeys
	"Answer a set containing the cached objects in the receiver"

	^self contents keys asSet! !

!Cache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:17'!
cachedValueFor: anObject
	"Answer the cached value for anObject. If no cached value is available, answer nil"

	^self contents at: anObject ifAbsent: []! !

!Cache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:27'!
forget: anObject
	"Remove anObject and its cached value from the receiver. Answer the value forgotten"

	^self contents removeKey: anObject! !

!Cache methodsFor: 'Enumerating' stamp: 'SqR 11/25/97 06:26'!
forgetAllThat: aBlock
	"Forget all values for objects such that aBlock evaluates true on them"

	(self cachedKeys select: aBlock) do: [:each | self forget: each]
	! !

!Cache methodsFor: 'Testing' stamp: 'SqR 11/25/97 06:14'!
hasCachedValueFor: anObject
	"Answer true if the receiver has a cached value for anObject"

	^self contents includesKey: anObject! !

!Cache methodsFor: 'Private-Accessors' stamp: 'SqR 11/25/97 06:06'!
contents
	"Answer the contents"

	^contents! !

!Cache methodsFor: 'Private-Accessors' stamp: 'SqR 11/25/97 06:06'!
contents: anObject
	"Set the contents to anObject"

	contents := anObject! !

!Cache methodsFor: 'Private-Initializing' stamp: 'SqR 11/25/97 06:05'!
initialize
	"Initialize the receiver"

	self contents: Dictionary new! !


!Cache class reorganize!
('Instance creation' new)
!


!Cache class methodsFor: 'Instance creation' stamp: 'SqR 11/25/97 06:05'!
new
	"Answer a new instance of the receiver"

	^super new initialize! !


!CachedObjectRaiser reorganize!
('Calculating' raiseToInteger:)
('Private-Initializing' initialize:)
('Private-Accessors' powerCache powerCache: target target:)
!


!CachedObjectRaiser methodsFor: 'Calculating' stamp: 'SqR 2/15/98 23:24'!
raiseToInteger: anInteger
	"Answer the target raised to integer anInteger"

	| factors toGo lastPower anIntegerHalf answer |

	anIntegerHalf := anInteger >> 1 + 1.
	[(lastPower := self powerCache sortedCachedKeys last) < anIntegerHalf] whileTrue:
		[self powerCache at: lastPower << 1 put: (self powerCache at: lastPower) squared].
	factors := OrderedCollection new.
	toGo := anInteger abs.
	self powerCache sortedCachedKeys reverseDo:
		[:each |
			each <= toGo ifTrue:
				[
					factors add: (self powerCache at: each).
					(toGo := toGo - each) = 0 ifTrue:
						[
							answer := CollectionProduct seqCollection: factors.
							^anInteger negative ifTrue: [answer reciprocal] ifFalse: [answer]
						]
				]
		]! !

!CachedObjectRaiser methodsFor: 'Private-Initializing' stamp: 'SqR 11/25/97 06:39'!
initialize: anObject
	"Initialize the receiver"

	self 
		powerCache: KeySortingCache new;
		target: anObject.
	self powerCache 
		at: 0 put: self target multiplicativeIdentity;
		at: 1 put: self target! !

!CachedObjectRaiser methodsFor: 'Private-Accessors' stamp: 'SqR 11/21/97 12:17'!
powerCache
	"Answer the power cache"

	^powerCache! !

!CachedObjectRaiser methodsFor: 'Private-Accessors' stamp: 'SqR 11/21/97 12:17'!
powerCache: anObject
	"Set the power cache to anObject"

	powerCache := anObject! !

!CachedObjectRaiser methodsFor: 'Private-Accessors' stamp: 'SqR 11/21/97 12:26'!
target
	"Answer the target"

	^target! !

!CachedObjectRaiser methodsFor: 'Private-Accessors' stamp: 'SqR 11/21/97 12:27'!
target: anObject
	"Set the target to anObject"

	target := anObject! !


!CachedObjectRaiser class reorganize!
('Instance creation' new new:)
!


!CachedObjectRaiser class methodsFor: 'Instance creation' stamp: 'SqR 11/25/97 06:54'!
new
	"Answer an error"

	^self shouldNotImplement! !

!CachedObjectRaiser class methodsFor: 'Instance creation' stamp: 'SqR 11/21/97 12:25'!
new: anObject
	"Answer a new instance of the receiver"

	^super new initialize: anObject! !


!Collection methodsFor: 'enumerating' stamp: 'SqR 10/28/97 00:14'!
do: aBlock andBetweenDo: aSeparatorBlock
	"Evaluate aBlock for each element of the receiver, evaluating aSeparatorBlock
	between each pair of evaluations of aBlock"

	| first |

	first := true.
	self do:
		[:each |
			first
				ifTrue: [first := false]
				ifFalse: [aSeparatorBlock value].
			aBlock value: each.
		]! !


!CollectionProduct reorganize!
('private' product: productBetween:and: temporal temporal:)
!


!CollectionProduct methodsFor: 'private' stamp: 'SqR 11/4/97 02:50'!
product: aSeqCollection
	"Answer the product of all the elements in aSeqCollection"

	^self temporal: aSeqCollection; productBetween: 1 and: self temporal size! !

!CollectionProduct methodsFor: 'private' stamp: 'SqR 2/15/98 23:24'!
productBetween: start and: end
	"Answer the product of the elements between positions start and end of the temporal"

	| m |

	start >= end ifTrue: [^self temporal at: end].
	^(self productBetween: start and: (m := start + end >> 1)) * (self productBetween: m + 1 and: end)! !

!CollectionProduct methodsFor: 'private' stamp: 'SqR 11/3/97 23:04'!
temporal
	"Answer the temporal"

	^temporal! !

!CollectionProduct methodsFor: 'private' stamp: 'SqR 11/25/97 15:50'!
temporal: anObject
	"Set the temporal to anObject"

	temporal := anObject! !


!CollectionProduct class reorganize!
('comments' documentation)
('Testing' seqCollection: seqCollection:ifEmpty:)
!


!CollectionProduct class methodsFor: 'comments' stamp: 'SqR 11/4/97 02:06'!
documentation
	"This is the documentation for the receiver"

"Hi. My instances take a sequenceable collection and answer the product of all the elements of the collection.
It assumes that the elements understand the binary message #*. They use a recursive algorithm and it is very
fast. It builds up the product by taking pairs of elements and then taking the results of those products in
pairs, and so on. For doing this, my instances assume that the product of the elements is commutative and 
associative. Examples follow:

10 factorial
CollectionProduct seqCollection: #(1 2 3 4 5 6 7 8 9 10) 

24 descendentPower: 10
CollectionProduct seqCollection: (15 to: 24)

10 primeFactorial
CollectionProduct seqCollection: #(2 3 5 7 11 13 17 19 23 29)

Say that somehow you've come up with the factorization of a given object, like a polynomial, an integer
or any other number, and now you have the factorization stored in the sequenceable collection factors. 
Then, you can check you've done the calculations right by doing:

CollectionProduct seqCollection: factors


04/11/97, SqR!! using Squeak 1.23"! !

!CollectionProduct class methodsFor: 'Testing' stamp: 'SqR 11/3/97 22:21'!
seqCollection: aSeqCollection
	"Answer the product of all the elements in aSeqCollection"

	^super new product: aSeqCollection! !

!CollectionProduct class methodsFor: 'Testing' stamp: 'SqR 11/8/97 02:49'!
seqCollection: aSeqCollection ifEmpty: aValue
	"Answer the product of all the elements in aSeqCollection. Answer aValue if aSeqCollection is empty"

	^aSeqCollection isEmpty ifTrue: [aValue] ifFalse: [self seqCollection: aSeqCollection]! !


!ColumnTuple reorganize!
('Converting' asCol)
('Operating' transposed)
('Testing' colDim isColumn isRow rowDim)
!


!ColumnTuple methodsFor: 'Converting' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:45'!
asCol
	"Answer the receiver"! !

!ColumnTuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:47'!
transposed
	"Answer the receiver transposed"

	^self asRow! !

!ColumnTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:43'!
colDim
	"Answer the column dimension of the receiver"

	^self dim! !

!ColumnTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:18'!
isColumn
	^true! !

!ColumnTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:18'!
isRow
	^false! !

!ColumnTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:43'!
rowDim
	"Answer the row dimension of the receiver"

	^1! !


!GaussianRootFinder reorganize!
('Testing' test:)
('Private' candidatesForP: candidatesForQ: ensureInZ: fastOutDetermination: iterate: iterate:knowing:)
!


!GaussianRootFinder methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 17:23'!
test: aPolyInZ
	"Answer the rational roots of aPolyInZ, nothing if such poly	is not in Z[x]"

	| answer extras toGo possible |

	(self fastOutDetermination: aPolyInZ) ifTrue: [^SortedCollection new].
	answer _ SortedCollection new.
	possible _ SortedCollection new.
	toGo _ aPolyInZ.
		[
			extras _ self iterate: toGo knowing: possible.
			possible _ extras.
			(extras isEmpty or: [toGo degree = answer size]) ifTrue: [^answer].
			answer addAll: extras.
			toGo _ toGo // (aPolyInZ class xMinusALot: extras).
			true
		] whileTrue! !

!GaussianRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 16:52'!
candidatesForP: aPolyInZ
	"Answer the candidates for p"

	| term |

	^(term _ aPolyInZ atDegree: 0) isNil
		ifTrue: [0] ifFalse: [term scalar divisors]! !

!GaussianRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 15:25'!
candidatesForQ: aPolyInZ
	"Answer the candidates for q"

	^aPolyInZ head scalar divisors! !

!GaussianRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 01:35'!
ensureInZ: aPoly
	"Answer false if aPoly
	is not in Z[x]"

	| scalarAmbient |

	scalarAmbient _ ScalarAmbientRationals new.
	aPoly monomialsDo: 
		[:each | (scalarAmbient includes: each scalar) ifFalse: [^false]].
	^true! !

!GaussianRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 15:30'!
fastOutDetermination: aPolyInZ
	"Answer true if there's nothing to do"

	(self ensureInZ: aPolyInZ) ifFalse: [^true].
	aPolyInZ degree < 1 ifTrue: [^true].
	^false
! !

!GaussianRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 16:53'!
iterate: aPolyInZ
	"Apply an iteration of the Gauss theorem to aPolyInZ"

	| p q candidates answer polyDegree |

	candidates _ Set new.
	p _ self candidatesForP: aPolyInZ.
	q _ self candidatesForQ: aPolyInZ.
	p do: [:eachNum | q do: [:eachDen | candidates add: eachNum / eachDen]].
	answer _ SortedCollection new.
	polyDegree _ aPolyInZ degree.
	candidates do:
		[:each |
			(aPolyInZ valueAtScalar: each) = 0 ifTrue:
				[
					answer add: each.
					polyDegree = answer size ifTrue: [^answer].
				].
			(aPolyInZ valueAtScalar: each negated) = 0 ifTrue:
				[
					answer add: each.
					polyDegree = answer size ifTrue: [^answer].
				]
		].
	^answer! !

!GaussianRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 17:21'!
iterate: aPolyInZ knowing: possibleRoots
	"Apply Gauss to aPolyInZ. If possible roots
	are known, test only those in possibleRoots"

	^(possibleRoots isEmpty ifTrue: [self iterate: aPolyInZ]
		ifFalse: [possibleRoots asSet select: [:each | (aPolyInZ valueAtScalar: each) = 0]])
			asSortedCollection! !


!GaussianRootFinder class reorganize!
('Instance creation' new)
!


!GaussianRootFinder class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/16/1998 01:11'!
new
	"Answer an instance of the receiver"

	current isNil ifTrue: [current _ super new].
	^current! !


!KeySortingCache reorganize!
('Accessing' at:put: forget: sortedCachedKeys)
('Private-Accessors' keys keys:)
('Private-Initializing' initialize)
!


!KeySortingCache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 07:12'!
at: anObject put: aValue
	"Set the cached value for anObject to aValue. Answer aValue"

	self keys add: anObject.
	^super at: anObject put: aValue! !

!KeySortingCache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:31'!
forget: anObject
	"Forget the cached value for anObject. Answer the forgotten value"

	super forget: anObject.
	^self keys remove: anObject! !

!KeySortingCache methodsFor: 'Accessing' stamp: 'SqR 11/25/97 06:32'!
sortedCachedKeys
	"Answer a sorted collection with the keys of the receiver"

	^self keys! !

!KeySortingCache methodsFor: 'Private-Accessors' stamp: 'SqR 11/25/97 06:29'!
keys
	"Answer the keys of the receiver"

	^keys! !

!KeySortingCache methodsFor: 'Private-Accessors' stamp: 'SqR 11/25/97 06:29'!
keys: anObject
	"Set the keys of the receiver to anObject"

	keys := anObject! !

!KeySortingCache methodsFor: 'Private-Initializing' stamp: 'SqR 11/25/97 06:28'!
initialize
	"Initialize the receiver"

	super initialize.
	self keys: SortedCollection new! !


!Monomial reorganize!
('Accessing' at: at:put: head tail variables)
('Accessors' literal scalar)
('Converting' adaptFraction: adaptInteger: adaptToFraction adaptToInteger asMVPolynomial asSVPolynomial)
('Enumerating' monomialsDo:)
('Operating' * + - / derivativeAt: negated primitiveAt: reciprocal)
('Printing' printOn:)
('Testing' = degree hash isMonomial isNull valueAt:)
('Private-Initializing' initialize:by:)
('Private-Accessors' literal: scalar:)
!


!Monomial methodsFor: 'Accessing' stamp: 'SqR 1/4/98 09:57'!
at: aVariable
	"Answer the degree of aVariable"

	^self literal at: aVariable! !

!Monomial methodsFor: 'Accessing' stamp: 'SqR!!!! 8/15/1998 17:48'!
at: aVariable put: anInteger
	"Set the degree of aVariable to anInteger"

	self literal at: aVariable put: anInteger.
	degree _ literal degree! !

!Monomial methodsFor: 'Accessing' stamp: 'SqR 1/14/98 19:43'!
head
	"Answer the receiver"! !

!Monomial methodsFor: 'Accessing' stamp: 'SqR 1/14/98 19:43'!
tail
	"Answer the null monomial"

	^self class new: self scalar - self scalar by: PowerLiteral new! !

!Monomial methodsFor: 'Accessing' stamp: 'SqR 1/5/98 07:35'!
variables
	"Answer the variables of the receiver"

	^self literal variables! !

!Monomial methodsFor: 'Accessors' stamp: 'SqR 1/4/98 09:37'!
literal
	^literal! !

!Monomial methodsFor: 'Accessors' stamp: 'SqR 1/4/98 09:37'!
scalar
	^scalar! !

!Monomial methodsFor: 'Converting' stamp: 'SqR 1/14/98 19:36'!
adaptFraction: aFraction
	"Adapt aFraction to operate with the receiver"

	^aFraction asMonomial! !

!Monomial methodsFor: 'Converting' stamp: 'SqR 1/14/98 19:36'!
adaptInteger: anInteger
	"Adapt anInteger to operate with the receiver"

	^anInteger asMonomial! !

!Monomial methodsFor: 'Converting' stamp: 'SqR 1/14/98 19:37'!
adaptToFraction
	"Do nothing"! !

!Monomial methodsFor: 'Converting' stamp: 'SqR 1/14/98 19:37'!
adaptToInteger
	"Do nothing"! !

!Monomial methodsFor: 'Converting' stamp: 'SqR 1/5/98 06:26'!
asMVPolynomial
	"Answer the receiver as an MV polynomial"

	^MVPolynomial fromMonomial: self! !

!Monomial methodsFor: 'Converting' stamp: 'SqR 1/5/98 06:25'!
asSVPolynomial
	"Answer the receiver as an SV polynomial"

	^SVPolynomial fromMonomial: self! !

!Monomial methodsFor: 'Enumerating' stamp: 'SqR 1/14/98 19:41'!
monomialsDo: aBlock
	"Evaluate aBlock with all the monomials of the receiver"

	aBlock value: self! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/4/98 10:59'!
* aMonomialOrScalar
	"Answer the product of the receiver and aMonomialOrScalar"

	^aMonomialOrScalar isMonomial
		ifTrue: [self class new: self scalar * aMonomialOrScalar scalar by: self literal * aMonomialOrScalar literal]
		ifFalse: [self class new: self scalar * aMonomialOrScalar by: self literal]! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/5/98 07:34'!
+ anObject
	"Answer the sum between the receiver and anObject"

	^self variables size < 2
		ifTrue: [self asSVPolynomial + anObject]
		ifFalse: [self asMVPolynomial + anObject]! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/5/98 07:34'!
- anObject
	"Answer the receiver minus anObject"

	^self + anObject negated! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/4/98 10:59'!
/ aMonomialOrScalar
	"Answer the receiver divided by aMonomialOrScalar"

	^self * aMonomialOrScalar reciprocal! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:45'!
derivativeAt: aVariable
	"Answer the derivative of the receiver at the variable aVariable"

	^(self at: aVariable) = 0 
		ifTrue: [self class new: 0 by: PowerLiteral new]
		ifFalse: [self class new: self scalar * (self at: aVariable) by: self literal / aVariable asPowerLiteral]
	! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/4/98 11:20'!
negated
	"Answer the receiver negated"

	^self class new: self scalar negated by: self literal! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:57'!
primitiveAt: aVariable
	"Answer the primitive of the receiver at the variable aVariable"

	^(self at: aVariable) = -1
		ifTrue: [self error: 'Logarithmic primitive not yet handled']
		ifFalse: [self class new: self scalar / ((self at: aVariable) + 1) by: self literal * aVariable asPowerLiteral]
	! !

!Monomial methodsFor: 'Operating' stamp: 'SqR 1/4/98 11:00'!
reciprocal
	"Answer the reciprocal of the receiver"

	^self class new: self scalar reciprocal by: self literal reciprocal! !

!Monomial methodsFor: 'Printing' stamp: 'SqR 1/6/98 05:31'!
printOn: aStream
	"Append the representation of the receiver into aStream"

	self scalar negative ifTrue: [aStream nextPut: $-] ifFalse: [aStream nextPut: $+].
	self scalar abs printOn: aStream.
	self literal printOn: aStream! !

!Monomial methodsFor: 'Testing' stamp: 'SqR 1/5/98 00:50'!
= aMonomial
	"Answer true if the receiver is equal to aMonomial"

	^self scalar = aMonomial scalar and: [self literal = aMonomial literal]! !

!Monomial methodsFor: 'Testing' stamp: 'SqR!!!! 8/15/1998 17:49'!
degree
	"Answer the degree of the receiver"

	^degree! !

!Monomial methodsFor: 'Testing' stamp: 'SqR 1/5/98 00:51'!
hash
	"Answer the hash of the receiver"

	^(self literal hash * self scalar hash) hash! !

!Monomial methodsFor: 'Testing' stamp: 'SqR 1/4/98 10:58'!
isMonomial
	"Answer true"

	^true! !

!Monomial methodsFor: 'Testing' stamp: 'SqR 1/8/98 16:35'!
isNull
	"Answer true if the receiver is the null monomial"

	^self scalar - self scalar = self scalar! !

!Monomial methodsFor: 'Testing' stamp: 'SqR 1/4/98 11:17'!
valueAt: aDictionary
	"Refer to the comment of the #valueAt: method in PowerLiteral"

	^self scalar * (self literal valueAt: aDictionary)! !

!Monomial methodsFor: 'Private-Initializing' stamp: 'SqR!!!! 8/15/1998 17:47'!
initialize: aScalar by: aLiteral
	"Initialize the receiver"

	self
		scalar: aScalar;
		literal: aLiteral.
	degree _ literal degree! !

!Monomial methodsFor: 'Private-Accessors' stamp: 'SqR 1/4/98 09:37'!
literal: aLiteral
	literal := aLiteral! !

!Monomial methodsFor: 'Private-Accessors' stamp: 'SqR 1/4/98 09:37'!
scalar: aNumber
	scalar := aNumber! !


!Monomial class reorganize!
('Comments' comments)
('Instance creation' new:by:)
!


!Monomial class methodsFor: 'Comments' stamp: 'SqR 1/5/98 06:19'!
comments
	"Hi. Yes!! Yet more comment methods!!

	My instances model monomials, that is,
	a scalar multiplying a literal.

	Andres Valloud, aka SqR!!.
	January 5th, 1998
	"! !

!Monomial class methodsFor: 'Instance creation' stamp: 'SqR 1/4/98 09:38'!
new: aScalar by: aLiteral
	"Answer a new instance of the receiver"

	^super new initialize: aScalar by: aLiteral! !


!Number methodsFor: 'arithmetic' stamp: 'SqR!!!! 9/17/1998 22:08'!
/!! aNumber
	"Answer (self / aNumber) asFloat"

	^(self / aNumber) asFloat! !

!Number methodsFor: 'arithmetic' stamp: 'SqR!!!!!!!! 6/7/1998 19:39'!
semisum: aNumber
	"Answer the semisum of the receiver and aNumber"


	^self + aNumber // 2! !

!Number methodsFor: 'converting' stamp: 'SqR!!!!!!!! 6/7/1998 19:40'!
, aNumber
	"Answer the tuple (receiver, aNumber)"

	^Tuple with: (Array with: self with: aNumber)! !

!Number methodsFor: 'converting' stamp: 'SqR 1/5/98 07:48'!
asMonomial
	"Answer the receiver as a monomial"

	^Monomial new: self by: PowerLiteral new! !


!Fraction methodsFor: 'arithmetic' stamp: 'SqR!!!!!!!!!!!!!!!! 5/11/98 00:04'!
* aNumber
	"Answer the result of multiplying the receiver by aNumber."

	| adGcd bcGcd |

	aNumber isFraction
		ifTrue: 
			[
				adGcd := numerator gcd: aNumber denominator.
				bcGcd := denominator gcd: aNumber numerator.
				^(bcGcd = denominator and: [adGcd = aNumber denominator])
					ifFalse:
						[
							Fraction 
								numerator: (numerator // adGcd) * (aNumber numerator // bcGcd)
								denominator: (denominator // bcGcd) * (aNumber denominator // adGcd)
						]
					ifTrue: [(numerator // adGcd) * (aNumber numerator // bcGcd)]
			]
		ifFalse: [^ (aNumber adaptFraction: self) * aNumber adaptToFraction]! !

!Fraction methodsFor: 'arithmetic' stamp: 'SqR!!!!!!!!!!!!!!!! 5/10/98 23:49'!
+ aNumber
	"Answer the sum of the receiver and aNumber."

	| g barG barB barD newN newD |

	"Fraction>>#+ a la Leandro:

	| a1 d1 d2 b1 b2 |

	aNumber isFraction
		ifTrue:
			[
				d1 := denominator gcd: aNumber denominator.
				a1 := numerator * (b1 := aNumber denominator // d1) + (aNumber numerator * (b2 := denominator // d1)).
				d2 := a1 gcd: d1.
				d1 := b1 * b2 * (d1 // d2).
				^Fraction numerator: a1 // d2 denominator: d1
			]
		ifFalse: [adapt blah]
		
	"

	^aNumber isFraction
		ifTrue:
			[
				g := denominator gcd: aNumber denominator.
				barB := denominator // g.
				barD := aNumber denominator // g.
				newN := numerator * barD + (aNumber numerator * barB).
				barG := newN gcd: g.
				(newD := g // barG * barB * barD) = 1 
					ifFalse: [Fraction numerator: newN // barG denominator: newD]
					ifTrue: [newN // barG]
			]
		ifFalse: [(aNumber adaptFraction: self) + aNumber adaptToFraction]! !

!Fraction methodsFor: 'comparing' stamp: 'SqR 3/24/98 18:50'!
< aNumber

	"aNumber isFraction
		ifTrue: [aNumber numerator = 0
				ifTrue: [^numerator < 0]
				ifFalse: [^self - aNumber < 0]]
		ifFalse: [^(aNumber adaptFraction: self) < aNumber adaptToFraction]"
	
	aNumber isInteger ifTrue: [^aNumber * denominator > numerator].
	aNumber isFraction ifTrue: [^numerator * aNumber denominator < (denominator * aNumber numerator)]
						ifFalse: [^ (aNumber adaptFraction: self) < aNumber adaptToFraction]! !

!Fraction methodsFor: 'others' stamp: 'SqR!!!! 7/31/1998 00:50'!
raisedToInteger: anInteger
	"Answer the receiver raised to anInteger"

	anInteger = 0 ifTrue: [^1].
	
anInteger < 0 ifTrue: [^self reciprocal raisedToInteger: 0 - anInteger].
	^Fraction
		numerator: (self numerator raisedToInteger: anInteger)
		denominator: (self denominator raisedToInteger: anInteger)! !


!NumberInterval reorganize!
('Accessing' center size start stop)
('Converting' asClosed asClosedOpen asOpen asOpenClosed)
('Operating' addWidth: addWidthToIntegerBounds disect:)
('Printing' printOn:)
('Testing' includes: isClosed isClosedOpen isOpen isOpenClosed)
('Private' initialize:to:)
!


!NumberInterval methodsFor: 'Accessing' stamp: 'SqR!!!! 8/17/1998 14:56'!
center
	"Answer the center of the receiver"

	^(start + stop) / 2! !

!NumberInterval methodsFor: 'Accessing' stamp: 'SqR!!!! 8/16/1998 00:33'!
size
	"Answer the size of the receiver"

	^stop - start max: 0! !

!NumberInterval methodsFor: 'Accessing' stamp: 'SqR!!!! 8/16/1998 00:33'!
start
	^start! !

!NumberInterval methodsFor: 'Accessing' stamp: 'SqR!!!! 8/16/1998 00:33'!
stop
	^stop! !

!NumberInterval methodsFor: 'Converting' stamp: 'SqR!!!! 8/16/1998 18:58'!
asClosed
	"Convert the receiver"

	^ClosedInterval from: start to: stop! !

!NumberInterval methodsFor: 'Converting' stamp: 'SqR!!!! 8/16/1998 18:59'!
asClosedOpen
	"Convert the receiver"

	^ClosedOpenInterval from: start to: stop! !

!NumberInterval methodsFor: 'Converting' stamp: 'SqR!!!! 8/16/1998 18:58'!
asOpen
	"Convert the receiver"

	^OpenInterval from: start to: stop! !

!NumberInterval methodsFor: 'Converting' stamp: 'SqR!!!! 8/16/1998 18:59'!
asOpenClosed
	"Convert the receiver"

	^OpenClosedInterval from: start to: stop! !

!NumberInterval methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 01:50'!
addWidth: aNumber
	"Add aNumber to the stop and subtract
	it from the start"

	start _ start - aNumber.
	stop _ stop + aNumber! !

!NumberInterval methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 14:42'!
addWidthToIntegerBounds
	"Blah!!"

	start _ start floor.
	stop _ stop ceiling! !

!NumberInterval methodsFor: 'Operating' stamp: 'SqR!!!! 8/16/1998 17:54'!
disect: anInteger
	"Disect the receiver into anInteger equal parts.
	Answer such parts in an ordered collection"

	| answer deltaX newStart newStop |

	answer _ OrderedCollection new: anInteger.
	deltaX _ self size / anInteger.
	newStart _ start.
	newStop _ start + deltaX.
	anInteger timesRepeat:
		[
			answer add: (self class from: newStart to: newStop).
			newStart _ newStop.
			newStop _ newStop + deltaX
		].
	^answer! !

!NumberInterval methodsFor: 'Printing' stamp: 'SqR!!!! 8/16/1998 00:37'!
printOn: aStream
	"Append the blah to the blergh"

	aStream nextPutAll: 'AbstractInterval('.
	start printOn: aStream.
	aStream nextPutAll: ', '.
	stop printOn: aStream.
	aStream nextPut: $)! !

!NumberInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:35'!
includes: aNumber
	"Answer true if the receiver
	includes aNumber"

	^self subclassResponsibility! !

!NumberInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:34'!
isClosed
	"Answer true if the receiver
	is what the selector says"

	^self subclassResponsibility! !

!NumberInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:34'!
isClosedOpen
	"Answer true if the receiver
	is what the selector says"

	^self subclassResponsibility! !

!NumberInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:34'!
isOpen
	"Answer true if the receiver
	is what the selector says"

	^self subclassResponsibility! !

!NumberInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:34'!
isOpenClosed
	"Answer true if the receiver
	is what the selector says"

	^self subclassResponsibility! !

!NumberInterval methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 00:32'!
initialize: aNumber to: aNumber2
	"Blah!!"

	start _ aNumber.
	stop _ aNumber2! !


!ClosedInterval reorganize!
('Printing' printOn:)
('Testing' includes: isClosed isClosedOpen isOpen isOpenClosed)
!


!ClosedInterval methodsFor: 'Printing' stamp: 'SqR!!!! 8/16/1998 00:41'!
printOn: aStream
	"Blah!!"

	aStream nextPut: $[.
	start printOn: aStream.
	aStream nextPutAll: ', '.
	stop printOn: aStream.
	aStream nextPut: $]! !

!ClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:39'!
includes: aNumber
	"Etc"

	^start <= aNumber and: [aNumber <= stop]! !

!ClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:37'!
isClosed
	"Duh!!"

	^true! !

!ClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:38'!
isClosedOpen
	"Duh!!"

	^false! !

!ClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:37'!
isOpen
	"Duh!!"

	^false! !

!ClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:38'!
isOpenClosed
	"Duh!!"

	^false! !


!ClosedOpenInterval reorganize!
('Printing' printOn:)
('Testing' includes: isClosed isClosedOpen isOpen isOpenClosed)
!


!ClosedOpenInterval methodsFor: 'Printing' stamp: 'SqR!!!! 8/16/1998 00:43'!
printOn: aStream
	"Blah!!"

	aStream nextPut: $[.
	start printOn: aStream.
	aStream nextPutAll: ', '.
	stop printOn: aStream.
	aStream nextPut: $)! !

!ClosedOpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:43'!
includes: aNumber
	"Etc"

	^start <= aNumber and: [aNumber < stop]! !

!ClosedOpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:44'!
isClosed
	"Duh!!"

	^false! !

!ClosedOpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:44'!
isClosedOpen
	"Duh!!"

	^true! !

!ClosedOpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:44'!
isOpen
	"Duh!!"

	^false! !

!ClosedOpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:44'!
isOpenClosed
	"Duh!!"

	^false! !


!NumberInterval class reorganize!
('Instance creation' from:to:)
!


!NumberInterval class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/16/1998 00:32'!
from: aNumber to: aNumber2
	"Answer a blablabla, you already know"

	^super new initialize: aNumber to: aNumber2! !


!ObjectRaiser reorganize!
('Calculating' raise:toInteger:)
!


!ObjectRaiser methodsFor: 'Calculating' stamp: 'SqR 2/15/98 23:28'!
raise: anObject toInteger: anInteger
	"Raise anObject to integer anInteger"

	anInteger = 0 ifTrue: [^anObject multiplicativeIdentity].
	anInteger = 1 ifTrue: [^anObject].
	anInteger > 1 ifTrue: [^(self raise: anObject squared toInteger: anInteger >> 1) * (self raise: anObject toInteger: anInteger parity)].
	^(self raisedToInteger: anInteger negated) reciprocal! !


!BetterObjectRaiser reorganize!
('Calculating' raise:toInteger:)
!


!BetterObjectRaiser methodsFor: 'Calculating' stamp: 'SqR!!!! 8/16/1998 16:05'!
raise: anObject toInteger: anInteger
	"Answer anObject raised to integer anInteger"

	| factors toGo power |

	anInteger negative ifTrue: [^(self raise: anObject toInteger: 0 - anInteger) reciprocal].
	factors := OrderedCollection new.
	toGo := anInteger.
	power := anObject.
	[toGo = 0] whileFalse:
		[
			toGo odd ifTrue: [factors add: power].
			(toGo := toGo // 2) = 0 ifFalse: [power := power squared]
		].
	^CollectionProduct seqCollection: factors! !


!ObjectRaiser class reorganize!
('as yet unclassified')
!


!OpenClosedInterval reorganize!
('Printing' printOn:)
('Testing' includes: isClosed isClosedOpen isOpen isOpenClosed)
!


!OpenClosedInterval methodsFor: 'Printing' stamp: 'SqR!!!! 8/16/1998 00:42'!
printOn: aStream
	"Blah!!"

	aStream nextPut: $(.
	start printOn: aStream.
	aStream nextPutAll: ', '.
	stop printOn: aStream.
	aStream nextPut: $]! !

!OpenClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:42'!
includes: aNumber
	"Etc"

	^aNumber > start and: [aNumber <= stop]! !

!OpenClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:42'!
isClosed
	"Duh!!"

	^false! !

!OpenClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:43'!
isClosedOpen
	"Duh!!"

	^false! !

!OpenClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:42'!
isOpen
	"Duh!!"

	^false! !

!OpenClosedInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:43'!
isOpenClosed
	"Duh!!"

	^true! !


!OpenInterval reorganize!
('Printing' printOn:)
('Testing' includes: isClosed isClosedOpen isOpen isOpenClosed)
!


!OpenInterval methodsFor: 'Printing' stamp: 'SqR!!!! 8/16/1998 00:41'!
printOn: aStream
	"Blah!!"

	aStream nextPut: $(.
	start printOn: aStream.
	aStream nextPutAll: ', '.
	stop printOn: aStream.
	aStream nextPut: $)! !

!OpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:40'!
includes: aNumber
	"Etc"

	^start < aNumber and: [aNumber < stop]! !

!OpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:39'!
isClosed
	"Duh!!"

	^false! !

!OpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:39'!
isClosedOpen
	"Duh!!"

	^false! !

!OpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:39'!
isOpen
	"Duh!!"

	^true! !

!OpenInterval methodsFor: 'Testing' stamp: 'SqR!!!! 8/16/1998 00:39'!
isOpenClosed
	"Duh!!"

	^false! !


!Polynomial reorganize!
('Accessing' monomials)
('Copying' copy)
('Enumerating' monomialsDo:)
('Operating' * + - / derivativeAt: negated primitiveAt: raisedToInteger:)
('Printing' printOn:)
('Testing' = degree isNull valueAt:)
('Private' addMonomial: indexForLiteral:)
('Private-Accessors' monomials:)
('Private-Initializing' initialize initialize:)
!


!Polynomial methodsFor: 'Accessing' stamp: 'SqR 1/4/98 11:22'!
monomials
	^monomials! !

!Polynomial methodsFor: 'Copying' stamp: 'SqR 1/5/98 06:45'!
copy
	"Answer a copy of the receiver"

	^self class new monomials: self monomials copy.! !

!Polynomial methodsFor: 'Enumerating' stamp: 'SqR 1/5/98 06:27'!
monomialsDo: aBlock
	"Evaluate aBlock with each monomial of the receiver"

	self monomials do: aBlock! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/15/1998 14:38'!
* aPolyOrMonomial
	"Answer the receiver multiplied by aPolyOrMonomial"

	| answer argument |

	answer := self class new.
	argument _ aPolyOrMonomial.
	argument isNumber ifTrue: [argument _ argument asMonomial].
	self monomialsDo:
		[:each | argument monomialsDo:
			[:some | answer addMonomial: each * some]].
	^answer! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR 1/14/98 19:42'!
+ aPolynomialOrMonomial
	"Answer the sum of the receiver and a aPolynomialOrMonomial"

	| answer |

	answer := self copy.
	aPolynomialOrMonomial monomialsDo: [:some | answer addMonomial: some].
	^answer
	! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR 1/5/98 06:46'!
- aPolyOrMono
	"Answer the receiver minus aPolyOrMono"

	^self + aPolyOrMono negated! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/15/1998 14:37'!
/ aNumber
	"Answer the receiver divided by aNumber"

	^self * aNumber reciprocal asMonomial! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:47'!
derivativeAt: aVariable
	"Answer the derivative of the receiver"

	| answer |

	answer := self class new.
	self monomialsDo: [:each | answer := answer + (each derivativeAt: aVariable)].
	^answer! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/15/1998 15:34'!
negated
	"Answer the receiver negated"

	| answer newMons |

	answer := self class new.
	newMons _ answer monomials.
	self monomials do: [:each | newMons add: each negated].
	^answer! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:55'!
primitiveAt: aVariable
	"Answer the primitive of the receiver at the variable aVariable"

	| answer |

	answer := self class new.
	self monomialsDo: [:each | answer := answer + (each primitiveAt: aVariable)].
	^answer! !

!Polynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/16/1998 16:06'!
raisedToInteger: anInteger
	"Answer the receiver raised to anInteger"

	^BetterObjectRaiser new raise: self toInteger: anInteger! !

!Polynomial methodsFor: 'Printing' stamp: 'SqR 1/5/98 06:34'!
printOn: aStream
	"Append the representation of the receiver into aStream"

	self monomials isEmpty
		ifTrue: [0 printOn: aStream]
		ifFalse:
			[
				self monomials 
					do: [:each | each printOn: aStream]
					andBetweenDo: [aStream nextPut: $ ]
			]! !

!Polynomial methodsFor: 'Testing' stamp: 'SqR 1/8/98 16:48'!
= aPolynomial
	"Answer true if the receiver is equal to aPolynomial"

	^(self - aPolynomial) isNull! !

!Polynomial methodsFor: 'Testing' stamp: 'SqR!!!! 8/15/1998 17:53'!
degree
	"Answer the degree of the receiver"

	^monomials isEmpty ifTrue: [-1] ifFalse: [(monomials at: 1) degree]! !

!Polynomial methodsFor: 'Testing' stamp: 'SqR 1/8/98 16:38'!
isNull
	"Answer true if the receiver is the null polynomial"

	^(self monomials detect: [:one | one isNull not] ifNone: []) isNil! !

!Polynomial methodsFor: 'Testing' stamp: 'SqR 1/8/98 09:38'!
valueAt: aDictionary
	"Answer the value at aDictionary. Check the 
	comments of #valueAt: in the Monomial class"

	| answer value |

	self monomialsDo:
		[:each |
			answer isNil 
				ifTrue: [answer := each valueAt: aDictionary]
				ifFalse: [answer := answer + (each valueAt: aDictionary)]
		].
	answer isNil ifTrue: [answer := (value := aDictionary detect: [:one | true]) - value].
	^answer! !

!Polynomial methodsFor: 'Private' stamp: 'SqR!!!! 8/15/1998 15:02'!
addMonomial: aMonomial
	"Add aMonomial to the receiver"

	| index temp toAdd |

	(index := self indexForLiteral: aMonomial literal) = 0
		ifTrue: [toAdd := aMonomial]
		ifFalse:
			[
				temp := self monomials at: index.
				self monomials removeAt: index.
				toAdd := Monomial new: temp scalar + aMonomial scalar by: temp literal
			].
	toAdd isNull ifFalse: [self monomials add: toAdd]! !

!Polynomial methodsFor: 'Private' stamp: 'SqR 1/14/98 20:30'!
indexForLiteral: aLiteral
	"Answer the index of the collection of monomials that
	contains a monomial with literal equal to aLiteral. If
	no such monomial is found, answer 0"

	| temp |

	1 to: self monomials size do:
		[:each |
			temp := self monomials at: each.
			temp degree < aLiteral degree ifTrue: [^0].
			temp literal = aLiteral ifTrue: [^each]
		].
	^0! !

!Polynomial methodsFor: 'Private-Accessors' stamp: 'SqR 1/4/98 11:22'!
monomials: anObject
	monomials := anObject! !

!Polynomial methodsFor: 'Private-Initializing' stamp: 'SqR 1/4/98 11:36'!
initialize
	"Initialize the receiver"

	self monomials: (SortedCollection sortBlock: [:one :another | one degree > another degree])! !

!Polynomial methodsFor: 'Private-Initializing' stamp: 'SqR 1/4/98 11:49'!
initialize: aMonomial
	"Initialize the receiver"

	self initialize monomials add: aMonomial! !


!Polynomial class reorganize!
('Instance creation' constant: fromMonomial: new)
('Comments' comments)
!


!Polynomial class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/16/1998 15:47'!
constant: aNumber
	"Answer aNumber as a polynomial"

	^self new + aNumber asMonomial! !

!Polynomial class methodsFor: 'Instance creation' stamp: 'SqR 1/4/98 11:27'!
fromMonomial: aMonomial
	"Answer aMonomial as an instance of the receiver"

	^self new initialize: aMonomial! !

!Polynomial class methodsFor: 'Instance creation' stamp: 'SqR 1/4/98 11:22'!
new
	"Answer a new instance of the receiver"

	^super new initialize! !

!Polynomial class methodsFor: 'Comments' stamp: 'SqR 1/5/98 06:18'!
comments
	"Hi... how to tell you this is a comment message in
	a way I've not done before... hard task is that...

	My instances model abstract polynomials. It's basic
	behavior is modeled, together with accessors and
	support for basic operations as summing, mulling
	and so on. Have fun, and check my subclasses too.
	They should be SVPolynomial (SV for single-variable)
	and MVPolynomial (MV for multi-variable). But...
	perhaps another hierarchy will grow up. Who
	knows what can happen in Smalltalk...

	... or in human minda...

	Oh well, it's pretty much the same.

	Andres Valloud, aka SqR!!.
	January 5th, 1998
	"! !


!PowerLiteral reorganize!
('Accessing' at: at:add: at:put: variables)
('Converting' adaptFraction: adaptInteger: adaptToFraction adaptToInteger)
('Enumerating' variablesDo:)
('Operating' * / gcd: lcm: raisedTo: reciprocal)
('Printing' printOn:)
('Testing' = degree hash isPowerLiteral valueAt:)
('Private-Accessors' literal literal:)
('Private-Initializing' initialize)
!


!PowerLiteral methodsFor: 'Accessing' stamp: 'SqR 1/4/98 09:12'!
at: aVariable
	"Answer the power of aVariable"

	^self literal at: aVariable ifAbsent: [0]! !

!PowerLiteral methodsFor: 'Accessing' stamp: 'SqR!!!! 8/16/1998 02:00'!
at: aVariable add: aDeltaPower
	"Add aDeltaPower to the power of aVariable"

	self at: aVariable put: (self at: aVariable) + aDeltaPower! !

!PowerLiteral methodsFor: 'Accessing' stamp: 'SqR!!!! 8/15/1998 17:37'!
at: aVariable put: aPower
	"Set the power of aVariable to aPower. If aPower is zero, remove
	aVariable from the receiver"

	degree _ degree - (self at: aVariable) + aPower.
	aPower = 0 
		ifTrue: [self literal removeKey: aVariable ifAbsent: []]
		ifFalse: [self literal at: aVariable put: aPower]! !

!PowerLiteral methodsFor: 'Accessing' stamp: 'SqR 1/4/98 09:22'!
variables
	"Answer the variables of the receiver"

	^self literal keys! !

!PowerLiteral methodsFor: 'Converting' stamp: 'SqR 1/14/98 19:33'!
adaptFraction: aFraction
	"Adapt anInteger to operate with myself"

	^aFraction asMonomial! !

!PowerLiteral methodsFor: 'Converting' stamp: 'SqR 1/8/98 07:44'!
adaptInteger: anInteger
	"Adapt anInteger to operate with myself"

	^anInteger asMonomial! !

!PowerLiteral methodsFor: 'Converting' stamp: 'SqR 1/14/98 19:33'!
adaptToFraction
	"Adapt myself to operate with aFraction. Convert myself to a monomial"

	^Monomial new: 1 by: self! !

!PowerLiteral methodsFor: 'Converting' stamp: 'SqR 1/8/98 07:46'!
adaptToInteger
	"Adapt myself to operate with anInteger. Convert myself to a monomial"

	^Monomial new: 1 by: self! !

!PowerLiteral methodsFor: 'Enumerating' stamp: 'SqR 1/4/98 09:21'!
variablesDo: aBlock
	"Evaluate aBlock with each variable of the receiver"

	self literal keysDo: aBlock! !

!PowerLiteral methodsFor: 'Operating' stamp: 'SqR 1/4/98 11:12'!
* aLiteralOrOther
	"Answer the product of the receiver and aLiteral"

	| answer |

	^aLiteralOrOther isPowerLiteral ifTrue:
		[
			answer := self class new.
			self variablesDo: [:each | answer at: each put: (self at: each)].
			aLiteralOrOther variablesDo: [:some | answer at: some add: (aLiteralOrOther at: some)].
			answer
		] ifFalse: [Monomial new: aLiteralOrOther by: self]! !

!PowerLiteral methodsFor: 'Operating' stamp: 'SqR 1/8/98 08:03'!
/ anObject
	"Answer the received divided by aLiteral"

	^self * anObject reciprocal! !

!PowerLiteral methodsFor: 'Operating' stamp: 'SqR 1/4/98 09:28'!
gcd: aLiteral
	"Answer the gcd between the receiver and aLiteral"

	| answer |

	answer := self class new.
	(self variables select: [:each | aLiteral variables includes: each]) do:
		[:some | answer at: some put: ((self at: some) min: (aLiteral at: some))].
	^answer
	! !

!PowerLiteral methodsFor: 'Operating' stamp: 'SqR 1/5/98 00:00'!
lcm: aLiteral
	"Answer the lcm between the receiver and aLiteral"

	| answer |

	answer := self class new.
	(self variables addAll: aLiteral variables) asSet do:
		[:each | answer at: each put: ((self at: each) max: (aLiteral at: each))].
	^answer! !

!PowerLiteral methodsFor: 'Operating' stamp: 'SqR 1/4/98 09:24'!
raisedTo: aNumber
	"Answer the receiver raised to power aNumber"

	| answer |

	answer := self class new.
	self variablesDo: [:each | answer at: each put: (self at: each) * aNumber].
	^answer! !

!PowerLiteral methodsFor: 'Operating' stamp: 'SqR 1/4/98 09:32'!
reciprocal
	"Answer the reciprocal of the receiver"

	| answer |

	answer := self class new.
	self variablesDo: [:each | answer at: each put: (self at: each) negated].
	^answer! !

!PowerLiteral methodsFor: 'Printing' stamp: 'SqR 1/14/98 19:34'!
printOn: aStream
	"Append the representation of the receiver into aStream"

	self variables asSortedCollection do:
		[:each |
			each printOn: aStream.
			aStream nextPut: $^.
			(self literal at: each) printOn: aStream
		] andBetweenDo: [aStream nextPut: $ ]! !

!PowerLiteral methodsFor: 'Testing' stamp: 'SqR 1/5/98 00:49'!
= aLiteral
	"Answer true if the receiver is equal to aLiteral"

	^self literal = aLiteral literal! !

!PowerLiteral methodsFor: 'Testing' stamp: 'SqR!!!! 8/15/1998 17:45'!
degree
	"Answer the degree of the receiver"

	"degree isNil ifTrue: [degree _ literal inject: 0 into: [:total :each | total + each]]."
	^degree! !

!PowerLiteral methodsFor: 'Testing' stamp: 'SqR 1/5/98 00:50'!
hash
	"Answer the hash for the receiver"

	^self literal hash! !

!PowerLiteral methodsFor: 'Testing' stamp: 'SqR 1/4/98 10:20'!
isPowerLiteral
	"Answer true"

	^true! !

!PowerLiteral methodsFor: 'Testing' stamp: 'SqR 1/4/98 11:10'!
valueAt: aDictionary
	"Answer the value the receiver evaluated at aDictionary, where the keys of the dictionary are the variables used by
	the receiver, and the values are the respective values for those variables"

	| answer temp |

	self variablesDo:
		[:each |
			temp := (aDictionary at: each) raisedTo: (self at: each).
			answer isNil ifTrue: [answer := temp] ifFalse: [answer := answer * temp]
		].
	answer isNil ifTrue: [answer := (aDictionary detect: [:each | true]) raisedTo: 0].
	^answer! !

!PowerLiteral methodsFor: 'Private-Accessors' stamp: 'SqR 1/4/98 09:04'!
literal
	^literal! !

!PowerLiteral methodsFor: 'Private-Accessors' stamp: 'SqR 1/4/98 09:04'!
literal: anObject
	literal := anObject! !

!PowerLiteral methodsFor: 'Private-Initializing' stamp: 'SqR!!!! 8/15/1998 17:33'!
initialize
	"Initialize the receiver"

	self literal: Dictionary new.
	degree _ 0! !


!PowerLiteral class reorganize!
('Comments' comments)
('Instance creation' fromSymbol: new)
!


!PowerLiteral class methodsFor: 'Comments' stamp: 'SqR 1/4/98 09:35'!
comments
	"Hi. This can be quite boring, isn't it? That's why
	I try to be creative on this... sorry. I've got no new
	ideas on how to tell you that this is yet an n-esimal
	comment method.

	My instances model products of variables to powers.

	Andres Valloud, aka SqR!!.
	January 4th, 1998
	"! !

!PowerLiteral class methodsFor: 'Instance creation' stamp: 'SqR 1/14/98 19:28'!
fromSymbol: aSymbol
	"Answer a new instance of the receiver with variables taken from aSymbol"

	| answer |

	answer := self new.
	aSymbol do: [:each | answer at: each asSymbol add: 1].
	^answer! !

!PowerLiteral class methodsFor: 'Instance creation' stamp: 'SqR 1/4/98 09:03'!
new
	"Answer a new instance of the receiver"

	^super new initialize! !


!QuickSearch reorganize!
('Searching' findFirst: qDupeSearch: qSearch: setTargetTo:)
('Private-Accessors' collection collection: target target:)
('Private-Initializing' initialize:)
('Private-Searching' dupeSearchFrom:to: findFirstFrom:to: is:leq: qDupeSearchFrom:to: qSearchFrom:to:)
!


!QuickSearch methodsFor: 'Searching' stamp: 'SqR 1/14/98 20:05'!
findFirst: aBlock
	"Answer the first element in the collection that
	makes aBlock evaluate to true. It is assumed that
	aBlock induces an order in the collection and that
	such collection is already sorted with respect to
	aBlock"

	^self collection size = 0 
		ifTrue: [0]
		ifFalse:
			[
				self 
					target: aBlock;
					findFirstFrom: 1 to: self collection size
			]! !

!QuickSearch methodsFor: 'Searching' stamp: 'SqR 1/14/98 20:03'!
qDupeSearch: anObject
	"Answer the index of anObject in the collection"

	^self collection size = 0 
		ifTrue: [0]
		ifFalse:
			[
				self 
					target: anObject;
					qDupeSearchFrom: 1 to: self collection size
			]! !

!QuickSearch methodsFor: 'Searching' stamp: 'SqR 1/14/98 20:04'!
qSearch: anObject
	"Answer the index of anObject in the collection"

	^self collection size = 0 
		ifTrue: [0]
		ifFalse:
			[
				self
					target: anObject;
					qSearchFrom: 1 to: self collection size
			]! !

!QuickSearch methodsFor: 'Searching' stamp: 'SqR!!!!!!!! 6/18/1998 16:08'!
setTargetTo: aCollection
	"Set the search target to aCollection"

	self target: aCollection! !

!QuickSearch methodsFor: 'Private-Accessors' stamp: 'SqR 1/12/98 12:09'!
collection
	^collection! !

!QuickSearch methodsFor: 'Private-Accessors' stamp: 'SqR 1/12/98 12:09'!
collection: anObject
	collection := anObject! !

!QuickSearch methodsFor: 'Private-Accessors' stamp: 'SqR 1/11/98 15:31'!
target
	^target! !

!QuickSearch methodsFor: 'Private-Accessors' stamp: 'SqR 1/11/98 15:31'!
target: anObject
	target := anObject! !

!QuickSearch methodsFor: 'Private-Initializing' stamp: 'SqR 1/12/98 12:09'!
initialize: aCollection
	"Initialize the receiver"

	self collection: aCollection! !

!QuickSearch methodsFor: 'Private-Searching' stamp: 'SqR 1/12/98 13:14'!
dupeSearchFrom: first to: last
	"Search for anObject in the indexes between first and last,
	except in the index first + last // 2"

	| testedLeft testedRight candidateLeft candidateRight topLeft topRight |

	last - first < 16 ifTrue: [^(first to: last) detect: [:one | self target = (self collection at: one)] ifNone: [0]].
	testedLeft := testedRight := first semisum: last.
	topLeft := first. topRight := last.
	[topLeft = testedLeft] whileFalse:
		[
			candidateLeft := topLeft semisum: testedLeft - 1.
			(self is: (self collection at: candidateLeft) leq: self target)
				ifTrue:
					[
						candidateLeft to: testedLeft - 1 do:
							[:each | self target = (self collection at: each) ifTrue: [^each]].
						testedLeft := candidateLeft
					]
				ifFalse: [topLeft := candidateLeft + 1]
		].
	[topRight = testedRight] whileFalse:
		[
			candidateRight := testedRight + 1 semisum: topRight.
			(self is: self target leq: (self collection at: candidateRight))
				ifTrue:
					[
						testedRight + 1 to: candidateRight do:
							[:some | self target = (self collection at: some) ifTrue: [^some]].
						testedRight := candidateRight.
					]
				ifFalse: [topRight := candidateRight - 1]
		].
	^0! !

!QuickSearch methodsFor: 'Private-Searching' stamp: 'SqR 1/14/98 20:40'!
findFirstFrom: first to: last
	"Answer the index of the first element in the collection that
	makes the target evaluate to true, Search only in the indexes 
	contained between first and last"

	| pivotIndex |

	last = first ifTrue: [^(self target value: (self collection at: first)) ifTrue: [first] ifFalse: [0]].
	(self target value: (self collection at: (pivotIndex := first semisum: last)))
		ifTrue: [^self findFirstFrom: first to: pivotIndex]
		ifFalse: [^self findFirstFrom: pivotIndex + 1 to: last]! !

!QuickSearch methodsFor: 'Private-Searching' stamp: 'SqR 1/12/98 12:09'!
is: anObject leq: anotherObject
	"Answer true if anObject is less than or equal to anotherObject
	with respect to the sort block of the collection"

	^self collection sortBlock value: anObject value: anotherObject! !

!QuickSearch methodsFor: 'Private-Searching' stamp: 'SqR 1/14/98 19:59'!
qDupeSearchFrom: first to: last
	"Answer the index of anObject in the target, Search only in the indexes 
	contained between first and last"

	| pivotIndex pivotElement |

	(pivotElement := self collection at: (pivotIndex := first semisum: last)) = self target ifTrue: [^pivotIndex].
	last = first ifTrue: [^0].
	(self is: self target leq: pivotElement)
		ifFalse: [^self qDupeSearchFrom: pivotIndex + 1 to: last]
		ifTrue:
			[
				(self is: pivotElement leq: self target)
					ifFalse: [^self qDupeSearchFrom: first to: pivotIndex - 1]
					ifTrue: [^self dupeSearchFrom: first to: last]
			]! !

!QuickSearch methodsFor: 'Private-Searching' stamp: 'SqR!!!!!!!! 6/18/1998 15:51'!
qSearchFrom: first to: last
	"Answer the index of anObject in the target, Search only in the indexes 
	contained between first and last"

	| bottom top pivot candidate |

	bottom _ first.
	top _ last.
	[bottom > top] whileFalse:
		[
			pivot _ bottom + top // 2.
			target = (candidate _ collection at: pivot) ifTrue: [^pivot].
			(self is: target leq: candidate)
				ifTrue: [top _ pivot - 1]
				ifFalse: [bottom _ pivot + 1]
		].
	^0! !


!QuickSearch class reorganize!
('Instance creation' new:)
!


!QuickSearch class methodsFor: 'Instance creation' stamp: 'SqR 1/11/98 15:50'!
new: aSortedCollection
	"Answer a new instance of the receiver"

	^super new initialize: aSortedCollection! !


!RowTuple reorganize!
('Converting' asRow)
('Operating' transposed)
('Testing' colDim isColumn isRow rowDim)
!


!RowTuple methodsFor: 'Converting' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:45'!
asRow
	"Answer the receiver"! !

!RowTuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:46'!
transposed
	"Answer the receiver transposed"

	^self asCol! !

!RowTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:43'!
colDim
	"Answer the column dimension of the receiver"

	^self dim! !

!RowTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:17'!
isColumn
	^false! !

!RowTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:17'!
isRow
	^true! !

!RowTuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:43'!
rowDim
	"Answer the row dimension of the receiver"

	^1! !


!SVPolynomial reorganize!
('Accessing' atDegree: head leadingCoef tail variable)
('Operating' // \\ derivative div: extractContents fractionShotgun gcd: primitive scalarCleanup)
('Querying' asMonic quadratFrei rootBounds sturmChain)
('Testing' degree valueAt: valueAtScalar:)
('Private' indexForLiteral:)
('Private-Accessors' qSearch)
!


!SVPolynomial methodsFor: 'Accessing' stamp: 'SqR!!!! 8/16/1998 01:24'!
atDegree: anInteger
	"Answer the monomial of degree anInteger, if any"

	| candidate monomial |

	^(candidate _ self qSearch findFirst: [:one | one degree <= anInteger]) = 0 ifFalse: 
		[
			monomial _ (monomials at: candidate).
			monomial degree = anInteger ifTrue: [monomial]
		]
! !

!SVPolynomial methodsFor: 'Accessing' stamp: 'SqR 1/6/98 08:51'!
head
	"Answer the monomial with the greatest degree"

	^self monomials first! !

!SVPolynomial methodsFor: 'Accessing' stamp: 'SqR!!!! 8/15/1998 14:36'!
leadingCoef
	"Answer the leading coefficient"

	^self head scalar! !

!SVPolynomial methodsFor: 'Accessing' stamp: 'SqR 1/6/98 05:05'!
tail
	"Answer all the monomials but the head"

	^self - self head! !

!SVPolynomial methodsFor: 'Accessing' stamp: 'SqR!!!! 8/8/1998 17:17'!
variable
	"Answer the variable of the receiver"

	^self head variables detect: [:each | true] ifNone: []! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:32'!
// anSVPoly
	"Answer the quotient of dividing the receiver by anSVPoly"

	^(self div: anSVPoly) at: 1! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:33'!
\\ anSVPoly
	"Answer the remainder of dividing the receiver by anSVPoly"

	^(self div: anSVPoly) at: 2! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:53'!
derivative
	"Answer the derivative of the receiver"

	^self derivativeAt: self variable! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR 1/14/98 19:43'!
div: anSVPoly
	"Answer an array containing the quotient and the
	remainder of the division of the receiver by anSVPoly"

	| toGo quotient quotientBit |

	quotient := self class new.
	toGo := self.
	[toGo degree < anSVPoly degree] whileFalse:
		[
			quotientBit := toGo head / anSVPoly head.
			toGo := toGo - (anSVPoly * quotientBit).
			quotient := quotient + quotientBit
		].
	^Array with: quotient with: toGo! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/16/1998 14:50'!
extractContents
	"Extract all the contents of the receiver"

	| pellets someScalar scalarsZ answer |

	pellets _ 0.
	scalarsZ _ ScalarAmbientIntegers new.
	self monomialsDo: 
		[:some |
			someScalar _ some scalar.
			(scalarsZ includes: someScalar) ifTrue:
				[pellets _ pellets gcd: some scalar]
		].
	pellets = 0
		ifTrue: [answer _ self]
		ifFalse: [answer _ self class new. self monomialsDo: [:each | answer _ each / pellets + answer]].
	^answer! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 17:49'!
fractionShotgun
	"Kill all the denominators in the receiver"

	| pellets scalarsQ scalarsZ someScalar answer |

	pellets _ 1.
	scalarsQ _ ScalarAmbientRationals new.
	scalarsZ _ ScalarAmbientIntegers new.
	self monomialsDo: 
		[:some |
			someScalar _ some scalar.
			((scalarsQ includes: someScalar) and: [(scalarsZ includes: someScalar) not])
				ifTrue: [pellets _ pellets lcm: some scalar denominator]
		].
	pellets _ pellets abs.
	pellets = 1
		ifTrue: [answer _ self]
		ifFalse: [answer _ self class new. self monomialsDo: [:each | answer _ each * pellets + answer]].
	^answer! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 03:48'!
gcd: aPolynomial
	"Answer the gcd between the receiver
	and aPolynomial"

	| a b temp |

	self degree < aPolynomial degree ifTrue: [^aPolynomial gcd: self].
	a _ self scalarCleanup.
	b _ aPolynomial scalarCleanup.
	[(temp _ (a \\ b) scalarCleanup) isNull] whileFalse:
		[
			a _ b.
			b _ temp
		].
	^b asMonic! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR 1/6/98 05:58'!
primitive
	"Answer the primitive of the receiver"

	^self primitiveAt: self variable! !

!SVPolynomial methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 03:49'!
scalarCleanup
	"Answer a copy of the receiver with
	fractions shotgunned and contents extracted"

	^self fractionShotgun extractContents! !

!SVPolynomial methodsFor: 'Querying' stamp: 'SqR!!!! 8/15/1998 14:36'!
asMonic
	"Answer a monic copy of the receiver"

	^self / self leadingCoef! !

!SVPolynomial methodsFor: 'Querying' stamp: 'SqR!!!! 8/15/1998 14:28'!
quadratFrei
	"Answer the receiver free of squares"

	^self // (self gcd: self derivative)! !

!SVPolynomial methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 01:49'!
rootBounds
	"Answer an interval where the
	real roots of the polynomial of
	the receiver must be"

	| monicPoly bigM |

	monicPoly _ self asMonic.
	bigM _ 0.
	monicPoly monomialsDo: [:each | bigM _ bigM + each scalar abs].
	bigM _ bigM max: 1.
	^OpenClosedInterval from: bigM negated to: bigM! !

!SVPolynomial methodsFor: 'Querying' stamp: 'SqR!!!! 8/15/1998 14:43'!
sturmChain
	"Answer the Sturm chain of the receiver"

	^SturmChain new: self! !

!SVPolynomial methodsFor: 'Testing' stamp: 'SqR!!!! 8/15/1998 17:55'!
degree
	"Answer the degree of the receiver. Reimplemented for speed"

	^monomials size = 0 ifTrue: [-1] ifFalse: [(monomials at: 1) degree]! !

!SVPolynomial methodsFor: 'Testing' stamp: 'SqR!!!! 8/8/1998 17:16'!
valueAt: anObject
	"Answer the receiver evaluated at anObject"

	^anObject isNumber
		ifTrue: [self valueAtScalar: anObject]
		ifFalse: [super valueAt: anObject]! !

!SVPolynomial methodsFor: 'Testing' stamp: 'SqR!!!! 8/17/1998 18:27'!
valueAtScalar: aScalar
	"Answer the value of the receiver evaluated at aScalar"

	| answer lastDegree currentDegree |

	lastDegree _ self degree + 1.
	answer _ aScalar - aScalar.
	self monomialsDo:
		[:each |
			currentDegree _ each degree.
			answer _ answer * (aScalar raisedToInteger: lastDegree - currentDegree) + each scalar.
			lastDegree _ currentDegree
		].
	^answer * (aScalar raisedToInteger: lastDegree)! !

!SVPolynomial methodsFor: 'Private' stamp: 'SqR 1/14/98 20:59'!
indexForLiteral: aLiteral
	"Answer the index of the collection of monomials that
	contains a monomial with literal equal to aLiteral. If
	no such monomial is found, answer 0"

	| answer |

	^(answer := self qSearch findFirst: [:one | one degree <= aLiteral degree]) = 0
		ifTrue: [0]
		ifFalse: [(self monomials at: answer) literal = aLiteral ifTrue: [answer] ifFalse: [0]]! !

!SVPolynomial methodsFor: 'Private-Accessors' stamp: 'SqR 1/14/98 20:33'!
qSearch
	^qSearch isNil 
		ifTrue: [qSearch := QuickSearch new: self monomials]
		ifFalse: [qSearch]! !


!SVPolynomial class reorganize!
('Instance creation' xBy: xMinus: xMinusALot:)
!


!SVPolynomial class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!!!!!!!!!! 5/13/98 17:37'!
xBy: aNumber
	"Answer the polynomial x by aNumber"

	^self fromMonomial: (Monomial new: aNumber by: #x asPowerLiteral)! !

!SVPolynomial class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/16/1998 01:36'!
xMinus: aNumber
	"Answer x - aNumber"

	^(self xBy: 1) - aNumber asMonomial! !

!SVPolynomial class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/17/1998 03:19'!
xMinusALot: aCollection
	"Answer a poly of the form (x - x0)(x - x1)...(x - xn)
	where the xi values are taken from aCollection"

	^CollectionProduct seqCollection:
		(aCollection collect: [:each | self xMinus: each])
			asOrderedCollection! !


!ScalarAmbient reorganize!
('Inquiring' identity isField zero)
('Printing' printOn:)
('Testing' = hash includes:)
!


!ScalarAmbient methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:56'!
identity
	"Answer the identity of the receiver"

	^self subclassResponsibility! !

!ScalarAmbient methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:58'!
isField
	^self subclassResponsibility! !

!ScalarAmbient methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:56'!
zero
	"Answer the zero of the receiver"

	^self subclassResponsibility! !

!ScalarAmbient methodsFor: 'Printing' stamp: 'SqR!!!!!!!! 7/24/1998 01:22'!
printOn: aStream
	"Blah!!"

	aStream nextPutAll: 'ScalarAmbient('.
	self identity printOn: aStream.
	aStream nextPutAll: ', '.
	self zero printOn: aStream.
	aStream nextPut: $)! !

!ScalarAmbient methodsFor: 'Testing' stamp: 'SqR!!!!!!!! 7/24/1998 01:18'!
= aScalarAmbient
	"Answer true if the receiver is equal to aScalarAmbient"

	^identity = aScalarAmbient identity and:
		[zero = aScalarAmbient zero]! !

!ScalarAmbient methodsFor: 'Testing' stamp: 'SqR!!!!!!!! 7/24/1998 01:18'!
hash
	"Answer the hash of the receiver"

	^identity hash bitXor: zero hash! !

!ScalarAmbient methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:01'!
includes: anObject
	"Answer true if the receiver includes anObject"

	^self subclassResponsibility! !


!ScalarAmbient class reorganize!
('Instance creation' current new)
!


!ScalarAmbient class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!! 7/24/1998 01:47'!
current
	"Answer the current instance of the receiver"

	current isNil ifTrue: [current := super new].
	^current! !

!ScalarAmbient class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/16/1998 14:48'!
new
	"Answer the current instance of the receiver"

	^self current! !


!ScalarAmbientFloats reorganize!
('Inquiring' identity isField zero)
('Testing' includes:)
!


!ScalarAmbientFloats methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:02'!
identity
	^1.0! !

!ScalarAmbientFloats methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:02'!
isField
	^false! !

!ScalarAmbientFloats methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:02'!
zero
	^0.0! !

!ScalarAmbientFloats methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:03'!
includes: anObject
	^anObject isFloat! !


!ScalarAmbientIntegers reorganize!
('Inquiring' identity isField zero)
('Printing' printOn:)
('Testing' includes:)
!


!ScalarAmbientIntegers methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!! 7/19/1998 23:17'!
identity
	^1! !

!ScalarAmbientIntegers methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!! 7/19/1998 23:17'!
isField
	^false! !

!ScalarAmbientIntegers methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!! 7/19/1998 23:17'!
zero
	^0! !

!ScalarAmbientIntegers methodsFor: 'Printing' stamp: 'SqR!!!!!!!! 7/24/1998 01:49'!
printOn: aStream
	"Blah!!"

	"aStream nextPutAll: 'ScalarAmbient(Z)'"
	aStream nextPut: $Z! !

!ScalarAmbientIntegers methodsFor: 'Testing' stamp: 'SqR!!!!!!!! 7/19/1998 23:17'!
includes: aNumber
	"Answer true if the receiver includes aNumber"

	^aNumber isKindOf: Integer! !


!ScalarAmbientRationals reorganize!
('Inquiring' identity isField zero)
('Printing' printOn:)
('Testing' includes:)
!


!ScalarAmbientRationals methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:57'!
identity
	^1! !

!ScalarAmbientRationals methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:58'!
isField
	^true! !

!ScalarAmbientRationals methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:57'!
zero
	^0! !

!ScalarAmbientRationals methodsFor: 'Printing' stamp: 'SqR!!!!!!!! 7/24/1998 01:49'!
printOn: aStream
	"Blah!!"

	"aStream nextPutAll: 'ScalarAmbient(Q)'"
	aStream nextPut: $Q! !

!ScalarAmbientRationals methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:02'!
includes: anObject
	^(anObject isKindOf: Integer) or: [anObject isFraction]! !

Smalltalk renameClassNamed: #LinearAmbient as: #ScalarRunAmbient!

!ScalarRunAmbient reorganize!
('Accessing' dim scalarAmbient)
('Inquiring' includes: scalarIdentity scalarZero)
('Printing' printOn:)
('Private' dim: scalarAmbient:)
!


!ScalarRunAmbient methodsFor: 'Accessing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:55'!
dim
	^dim! !

!ScalarRunAmbient methodsFor: 'Accessing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:55'!
scalarAmbient
	^scalarAmbient! !

!ScalarRunAmbient methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:26'!
includes: anObject
	"Answer true if the receiver includes anObject"

	^anObject dim = dim and: [anObject scalarAmbient = scalarAmbient]! !

!ScalarRunAmbient methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!! 7/24/1998 01:21'!
scalarIdentity
	^scalarAmbient identity! !

!ScalarRunAmbient methodsFor: 'Inquiring' stamp: 'SqR!!!!!!!! 7/24/1998 01:21'!
scalarZero
	^scalarAmbient zero! !

!ScalarRunAmbient methodsFor: 'Printing' stamp: 'SqR!!!!!!!! 7/24/1998 01:44'!
printOn: aStream
	"Blah!!"

	aStream nextPut: ${.
	self scalarAmbient printOn: aStream.
	aStream nextPut: $^.
	self dim printOn: aStream.
	aStream nextPut: $}! !

!ScalarRunAmbient methodsFor: 'Private' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:31'!
dim: anObject
	dim := anObject! !

!ScalarRunAmbient methodsFor: 'Private' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:56'!
scalarAmbient: aScalarAmbient
	scalarAmbient := aScalarAmbient! !

Smalltalk renameClassNamed: #ScalarArrayAmbient as: #ScalarArrayAmbient!

!ScalarArrayAmbient reorganize!
('Printing' printOn:)
!


!ScalarArrayAmbient methodsFor: 'Printing' stamp: 'SqR!!!!!!!! 7/24/1998 01:45'!
printOn: aStream
	"Blah!!"

	aStream nextPut: ${.
	self scalarAmbient printOn: aStream.
	aStream nextPutAll: '^('.
	self dim x printOn: aStream.
	aStream nextPut: $x.
	self dim y printOn: aStream.
	aStream nextPutAll: '))'! !


!ScalarRunAmbient class reorganize!
('Instance creation' new:dim:)
!


!ScalarRunAmbient class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 17:30'!
new: aScalarAmbient dim: dimension
	"Answer a new instance of the receiver"

	^super new
		scalarAmbient: aScalarAmbient;
		dim: dimension! !


!SturmChain reorganize!
('Accessing' at: polynomial size)
('Operating' extractContents fractionShotgun)
('Printing' printOn:)
('Testing' signChangeAt: signChangeBetween:and: valueAt:)
('Private' add: initialize)
!


!SturmChain methodsFor: 'Accessing' stamp: 'SqR!!!! 8/17/1998 03:12'!
at: anInteger
	"Answer the anIntegerth
	polynomial of the receiver"

	^chain at: anInteger! !

!SturmChain methodsFor: 'Accessing' stamp: 'SqR!!!! 8/17/1998 03:12'!
polynomial
	"Answer the polynomial the
	receiver is based on"

	^self at: 1! !

!SturmChain methodsFor: 'Accessing' stamp: 'SqR!!!! 8/17/1998 03:13'!
size
	"Answer the size of the receiver"

	^chain size! !

!SturmChain methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 18:27'!
extractContents
	"Extract all the contents of the polynomials in the receiver"

	chain _ chain collect: [:each | each extractContents]! !

!SturmChain methodsFor: 'Operating' stamp: 'SqR!!!! 8/17/1998 18:28'!
fractionShotgun
	"Kill all the denominators in the receiver"

	chain _ chain collect: [:each | each fractionShotgun]! !

!SturmChain methodsFor: 'Printing' stamp: 'SqR!!!! 8/15/1998 14:45'!
printOn: aStream
	"Blah!!"

	aStream cr.
	chain do: [:each | each printOn: aStream. aStream cr]! !

!SturmChain methodsFor: 'Testing' stamp: 'SqR!!!! 8/20/1998 02:00'!
signChangeAt: aNumber
	"Answer the amount of sign changes
	of the receiver at aNumber"

	| answer last |

	answer _ 0.
	last _ 0.
	(self valueAt: aNumber) do:
		[:each |
			each = 0 ifFalse:
				[
					last sign * each sign = -1 ifTrue: [answer _ answer + 1].
					last _ each
				]
		].
	^answer! !

!SturmChain methodsFor: 'Testing' stamp: 'SqR!!!! 8/20/1998 02:05'!
signChangeBetween: a and: b
	"Answer blah, the selector"

	^(self signChangeAt: a) - (self signChangeAt: b)! !

!SturmChain methodsFor: 'Testing' stamp: 'SqR!!!! 9/11/1998 23:56'!
valueAt: aScalar
	"Answer the chain evaluated at aScalar"

	^valueCache at: aScalar ifAbsentEvaluate:
		[chain collect: [:each | each valueAtScalar: aScalar]]! !

!SturmChain methodsFor: 'Private' stamp: 'SqR!!!! 8/15/1998 14:44'!
add: anSVPoly
	"Add anSVPoly to the receiver"

	chain add: anSVPoly! !

!SturmChain methodsFor: 'Private' stamp: 'SqR!!!! 9/11/1998 23:55'!
initialize
	"Blah!!"

	chain _ OrderedCollection new.
	valueCache _ Cache new! !


!SturmChain class reorganize!
('Instance creation' new:)
!


!SturmChain class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/17/1998 18:27'!
new: anSVPoly
	"Answer the sturm chain of anSVPoly"

	| fLastLast fLast temp answer |

	answer _ super new initialize.
	fLastLast _ anSVPoly quadratFrei scalarCleanup.
	fLast _ fLastLast derivative scalarCleanup.
	answer add: fLastLast.
	answer add: fLast.
	[fLast degree <= 0] whileFalse:
		[
			temp _ (fLastLast \\ fLast) negated scalarCleanup.
			fLastLast _ fLast.
			fLast _ temp.
			answer add: fLast
		].
	^answer! !


!SturmPlotter reorganize!
('Morphic interface' plotColumn:in: setupForm:)
('Plotting' answer plot:in: plotIn: polynomial polynomial:)
('Settings' colorPrecision colorPrecision: plotSize plotSize: sampleAmount sampleAmount:)
('Private' morphicWrapperClass)
('Private - Accessors' negColors negColors: poly poly: polyChain polyChain: posiColors posiColors: zeroColor zeroColor:)
('Private - Initializing' generateColorPalletes: initialize)
('Private - Plotting' borderSize drawFormBordersOn: formDimensionsFor: maxScaleValue)
!


!SturmPlotter methodsFor: 'Morphic interface' stamp: 'SqR!!!! 9/26/1998 00:34'!
plotColumn: anInteger in: anInterval
	"Plot the column anInteger"

	| stencilPosi currentX chainColors tempValue |

	currentX _ anInteger - 1 * (anInterval size / self sampleAmount) + anInterval start.
	chainColors _ (self polyChain valueAt: currentX) collect:
		[:eachValue | 
			eachValue = 0 ifTrue: [self zeroColor] ifFalse:
				[
					eachValue > 0
						ifTrue: 
							[
								tempValue _ eachValue min: self maxScaleValue.
								self posiColors at: (((tempValue + 1) log: logValue) ceiling min: self colorPrecision)
							]
						ifFalse: 
							[
								tempValue _ 0 - eachValue min: self maxScaleValue.
								self negColors at: (((tempValue + 1) log: logValue) ceiling min: self colorPrecision)
							]
				]
		].			
	stencilPosi _ anInteger - 1 @ 1 * (self plotSize x @ 0) + (self borderSize @ self borderSize).
	1 to: chainColors size do:
		[:colorSampleNo | 
			answer fill: (Rectangle origin: stencilPosi extent: self plotSize) fillColor: (chainColors at: colorSampleNo).
			stencilPosi _ 0 @ self plotSize y + stencilPosi.
			colorSampleNo = chainColors size ifFalse:
				[
					0 to: plotSize x do: [:eachX | answer colorAt: eachX @ 0 + stencilPosi put: Color white].
					stencilPosi _ 0 @ 1 + stencilPosi
				]
		]! !

!SturmPlotter methodsFor: 'Morphic interface' stamp: 'SqR!!!! 9/20/1998 01:48'!
setupForm: anInterval
	"Setup the form to be answered"

	answer _ Form extent: (self formDimensionsFor: anInterval) depth: 16.
	self drawFormBordersOn: answer! !

!SturmPlotter methodsFor: 'Plotting' stamp: 'SqR!!!! 9/14/1998 06:53'!
answer
	"Answer the last plot or the plot being plotted
	in its current state"

	^answer! !

!SturmPlotter methodsFor: 'Plotting' stamp: 'SqR!!!! 9/12/1998 00:54'!
plot: aPolynomial in: anInterval
	"Answer an image in aForm with the Sturm chain for 
	aPolynomial plotted on it, all through anInterval and 
	with the default colors which are:

		x A red pallete for positive values of polynomials
		x A blue pallete for negative values of polynomials
		x Full black for zero

	Also, the plotter allows presetting the height of each
	polynomial in the Sturm chain for aPolynomial, together
	with the thickness of each step of the interval and the
	amount of such steps. All these parameters make up for
	the final size of the image"

	self poly: aPolynomial.
	^self plotIn: anInterval! !

!SturmPlotter methodsFor: 'Plotting' stamp: 'SqR!!!! 9/26/1998 00:34'!
plotIn: anInterval
	"Answer the plotted Sturm theorem as described in plot:in:"

	| stencilPosi deltaX currentX chainColors tempValue |

	self setupForm: anInterval.
	deltaX _ anInterval size / self sampleAmount.
	currentX _ anInterval start.
	1 to: self sampleAmount do:
		[:eachSampleNo |
			chainColors _ (self polyChain valueAt: currentX) collect:
				[:eachValue | 
					eachValue = 0 ifTrue: [self zeroColor] ifFalse:
						[
							eachValue > 0 
								ifTrue: 
									[
										tempValue _ eachValue min: self maxScaleValue.
										self posiColors at: (((tempValue + 1) log: logValue) ceiling min: self colorPrecision)
									]
								ifFalse: 
									[
										tempValue _ 0 - eachValue min: self maxScaleValue.
										self negColors at: (((tempValue + 1) log: logValue) ceiling min: self colorPrecision)
									]
						]
				].			
			stencilPosi _ eachSampleNo - 1 @ 1 * (self plotSize x @ 0) + (self borderSize @ self borderSize).
			1 to: chainColors size do:
				[:colorSampleNo | 
					answer fill: (Rectangle origin: stencilPosi extent: self plotSize) fillColor: (chainColors at: colorSampleNo).
					stencilPosi _ 0 @ self plotSize y + stencilPosi.
					colorSampleNo = chainColors size ifFalse:
						[
							0 to: plotSize x do: [:eachX | answer colorAt: eachX @ 0 + stencilPosi put: Color white].
							stencilPosi _ 0 @ 1 + stencilPosi
						]
				].
			currentX _ currentX + deltaX.
		].
	^answer
	! !

!SturmPlotter methodsFor: 'Plotting' stamp: 'SqR!!!! 9/13/1998 02:01'!
polynomial
	"Answer the polynomial being traced"

	^self polyChain at: 1! !

!SturmPlotter methodsFor: 'Plotting' stamp: 'SqR!!!! 9/12/1998 23:32'!
polynomial: aPolynomial
	"Set aPolynomial as the default polynomial to trace"

	self poly: aPolynomial! !

!SturmPlotter methodsFor: 'Settings' stamp: 'SqR!!!! 9/12/1998 23:24'!
colorPrecision
	"Answer the amount of colors the receiver is
	using to plot either positive or negative values"

	^posiColors size! !

!SturmPlotter methodsFor: 'Settings' stamp: 'SqR!!!! 9/12/1998 23:24'!
colorPrecision: anInteger
	"Set the amount of colors the receiver is using 
	to plot either positive or negative values to anInteger"

	self generateColorPalletes: anInteger! !

!SturmPlotter methodsFor: 'Settings' stamp: 'SqR!!!! 9/11/1998 23:39'!
plotSize
	"Answer the size of a plot"

	^plotSize! !

!SturmPlotter methodsFor: 'Settings' stamp: 'SqR!!!! 9/11/1998 23:39'!
plotSize: aPoint
	"Set the size of a plot to aPoint"

	plotSize _ aPoint! !

!SturmPlotter methodsFor: 'Settings' stamp: 'SqR!!!! 9/12/1998 01:06'!
sampleAmount
	"Answer the current sampleAmount per plotted interval"

	^sampleAmount! !

!SturmPlotter methodsFor: 'Settings' stamp: 'SqR!!!! 9/12/1998 01:06'!
sampleAmount: aNumber
	"Set the current sampleAmount per 
	plotted interval to aNumber"

	sampleAmount _ aNumber! !

!SturmPlotter methodsFor: 'Private' stamp: 'SqR!!!! 9/19/1998 21:03'!
morphicWrapperClass
	^Smalltalk at: #SturmPlotterMorph ifAbsent: []! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/11/1998 23:14'!
negColors
	^negColors! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/11/1998 23:14'!
negColors: anIndexedCollection
	negColors _ anIndexedCollection! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/12/1998 23:27'!
poly
	^polyChain at: 1! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/12/1998 23:26'!
poly: aPolynomial
	self polyChain: (SturmChain new: aPolynomial)! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/12/1998 00:49'!
polyChain
	^polyChain! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/12/1998 00:49'!
polyChain: aPolyChain
	polyChain _ aPolyChain! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/11/1998 23:14'!
posiColors
	^posiColors! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/11/1998 23:14'!
posiColors: anIndexedCollection
	posiColors _ anIndexedCollection! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/11/1998 23:14'!
zeroColor
	^zeroColor! !

!SturmPlotter methodsFor: 'Private - Accessors' stamp: 'SqR!!!! 9/11/1998 23:15'!
zeroColor: aColor
	zeroColor _ aColor! !

!SturmPlotter methodsFor: 'Private - Initializing' stamp: 'SqR!!!! 9/26/1998 00:42'!
generateColorPalletes: anInteger
	"Generate the color palletes the receiver will use"

	| temp overColor overPrecision |

	self zeroColor: Color black.
	temp _ Array new: anInteger.
	overColor _ (anInteger * 37 / 100) floor.
	overPrecision _ anInteger + overColor.
	1 to: temp size do: [:each | temp at: each put: (Color r: each + overColor /!! overPrecision g: 0 b: 0)].
	self posiColors: temp.
	temp _ Array new: anInteger.
	1 to: temp size do: [:each | temp at: each put: (Color r: 0 g: 0 b: each + overColor /!! overPrecision)].
	self negColors: temp.
	logValue _ self maxScaleValue raisedTo: 1 / anInteger! !

!SturmPlotter methodsFor: 'Private - Initializing' stamp: 'SqR!!!! 9/12/1998 02:15'!
initialize
	"Initialize the receiver"

	self plotSize: 16@10 "Close enough to 1 + 5 sqrt / 2, BTW :)...".
	self colorPrecision: 256.
	self sampleAmount: 32! !

!SturmPlotter methodsFor: 'Private - Plotting' stamp: 'SqR!!!! 9/12/1998 03:45'!
borderSize
	^2! !

!SturmPlotter methodsFor: 'Private - Plotting' stamp: 'SqR!!!! 9/12/1998 02:13'!
drawFormBordersOn: aForm
	"Draw the border of the plot"

	aForm borderWidth: self borderSize color: Color green! !

!SturmPlotter methodsFor: 'Private - Plotting' stamp: 'SqR!!!! 9/12/1998 03:43'!
formDimensionsFor: anInterval
	"Answer the dimensions of the form
	contain data plotted in anInterval"

	^2 * self borderSize + (self sampleAmount * self plotSize x) @
		(2 * self borderSize + (self plotSize y + 1 * self polyChain size) - 1)! !

!SturmPlotter methodsFor: 'Private - Plotting' stamp: 'SqR!!!! 9/26/1998 00:33'!
maxScaleValue
	"Answer the maximum color scalable value"

	^1000! !


!SturmPlotter class reorganize!
('Instance creation' new)
!


!SturmPlotter class methodsFor: 'Instance creation' stamp: 'SqR!!!! 9/11/1998 23:03'!
new
	"Answer a new instance of the receiver"

	^super new initialize! !


!SturmPlotterMorph methodsFor: 'Drawing' stamp: 'SqR!!!! 9/27/1998 02:11'!
drawOn: aCanvas
	"Draw the receiver on aCanvas"

	image isNil ifTrue: [super drawOn: aCanvas] ifFalse: 
		[
			"self extent: self calculateExtent.
			aCanvas fillWhite: (self position extent: (self extent x @ self imageOffset y)).
			aCanvas fillWhite: 
				(self position x @ (self position y + self imageOffset y + image extent y) extent: 
				(self extent x @ self bottomRightExtra y)).
			aCanvas fillWhite: 
				(self position x @ (self position y + self imageOffset y) extent:
				(self imageOffset x @ image extent y)).
			aCanvas fillWhite:
				(self position x + image extent x + self imageOffset x @ (self position y + self imageOffset y) extent:
				(self bottomRightExtra x @ image extent y)).				
			aCanvas image: image at: self position + self imageOffset."
			self extent: image extent.
			super drawOn: aCanvas.
			aCanvas image: image at: self position
		]! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/27/1998 00:41'!
doubleClickMenu: evt
	"Answer the double click menu"

	| menu |

	menu _ super doubleClickMenu: evt.
	menu add: 'update' target: self selector: #update.
	menu add: 'lastInterval' target: self selector: #lastInterval.
	^menu! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/26/1998 00:23'!
menuColorPrecision: anInteger
	"Perform #colorPrecision: from the drop menu"

	self initializeArguments.
	object colorPrecision: anInteger! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/26/1998 00:22'!
menuForDropping: aMorph event: evt 
	"Answer the menu to answer aMorph drop"

	| menu argument |

	argument _ (Array with: aMorph object).
	"menu _ super menuForDropping: aMorph event: evt."
	menu _ MenuMorph new.
	menu addLine.
	menu add: 'colorPrecision:' target: self selector: #menuColorPrecision: argumentList: argument.
	menu add: 'plotIn:' target: self selector: #menuPlotIn: argumentList: argument.
	menu add: 'plotSize:' target: self selector: #menuPlotSize: argumentList: argument.
	menu add: 'polynomial:' target: self selector: #menuPolynomial: argumentList: argument.
	menu add: 'sampleAmount:' target: self selector: #menuSampleAmount: argumentList: argument.
	^menu! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/19/1998 19:50'!
menuPlotIn: anInterval
	"Perform #plotIn: from the drop menu"

	self initializeArguments.
	self plotIn: anInterval! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/26/1998 01:11'!
menuPlotSize: aPoint
	"Perform #plotSize: from the drop menu"

	self initializeArguments.
	self isWorking
		ifFalse: [object plotSize: aPoint]
		ifTrue:
			[
				self stopWorking.
				object plotSize: aPoint.
				self startWorking
			]! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/19/1998 19:50'!
menuPolynomial: anSVPoly
	"Perform #polynomial: from the drop menu"

	self initializeArguments.
	self polynomial: anSVPoly! !

!SturmPlotterMorph methodsFor: 'Menues' stamp: 'SqR!!!! 9/26/1998 01:13'!
menuSampleAmount: anInteger
	"Perform #sampleAmount: from the drop menu"

	self initializeArguments.
	self isWorking 
		ifFalse: [object sampleAmount: anInteger]
		ifTrue:
			[
				self stopWorking.
				object sampleAmount: anInteger.
				self startWorking
			]! !

!SturmPlotterMorph methodsFor: 'Plotting' stamp: 'SqR!!!! 9/20/1998 19:30'!
plot: aPolynomial in: anInterval
	"Answer an image in aForm with the Sturm chain for 
	aPolynomial plotted on it, all through anInterval and 
	with the default colors which are:

		x A red pallete for positive values of polynomials
		x A blue pallete for negative values of polynomials
		x Full black for zero

	Also, the plotter allows presetting the height of each
	polynomial in the Sturm chain for aPolynomial, together
	with the thickness of each step of the interval and the
	amount of such steps. All these parameters make up for
	the final size of the image"

	lastInterval _ anInterval.
	self polynomial: aPolynomial.
	self startWorking
! !

!SturmPlotterMorph methodsFor: 'Plotting' stamp: 'SqR!!!! 9/20/1998 01:50'!
plotIn: anInterval
	"Plot the last given polynomial in anInterval"

	lastInterval _ anInterval.
	self startWorking
! !

!SturmPlotterMorph methodsFor: 'Plotting' stamp: 'SqR!!!! 9/23/1998 22:13'!
polynomial
	"Answer the polynomial being plotted"

	^object polynomial! !

!SturmPlotterMorph methodsFor: 'Plotting' stamp: 'SqR!!!! 9/23/1998 22:13'!
polynomial: anSVPoly
	"Set the polynomial being plotted to anSVPoly"

	object polynomial: anSVPoly! !

!SturmPlotterMorph methodsFor: 'Plotting' stamp: 'SqR!!!! 9/19/1998 20:46'!
update
	"Replot with new settings"

	self plotIn: lastInterval! !

!SturmPlotterMorph methodsFor: 'Stepping' stamp: 'SqR!!!! 9/23/1998 22:14'!
step
	"Perform a step"

	internalCount isNil ifFalse:
		[
			object plotColumn: internalCount in: lastInterval.
			internalCount _ internalCount + 1.
			image _ object answer.
			self updateContents.
			internalCount > object sampleAmount ifTrue: [self stopWorking]
		]! !

!SturmPlotterMorph methodsFor: 'Stepping' stamp: 'SqR!!!! 9/26/1998 01:09'!
stepTime
	"Answer the interval in ms between step requests"

	^0! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/27/1998 01:50'!
calculateExtraMorphs
	"Calculate the banners"

	intA isNil ifTrue: [intA _ TextMorph new].
	intA contents: lastInterval start printString.
	intB isNil ifTrue: [intB _ TextMorph new].
	intB contents: lastInterval stop printString.
	fZero isNil ifTrue: [fZero _ TextMorph new].
	fZero contents: 'F0'.
	fR isNil ifTrue: [fR _ TextMorph new].
	fR contents: 'F', object polyChain size printString! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/19/1998 19:42'!
image: anImageMorph
	image _ anImageMorph! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/20/1998 19:36'!
initialize
	"Initialize the receiver"

	self initialize: SturmPlotter new! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/27/1998 01:53'!
initialize: aPlotter
	"Initialize the receiver"

	self stopStepping.
	super initialize.
	object _ aPlotter! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/26/1998 01:11'!
isWorking
	"Answer true if the receiver is working"

	^internalCount isNil not! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/27/1998 00:41'!
lastInterval
	^lastInterval! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/27/1998 01:23'!
startWorking

	object setupForm: lastInterval.
	image _ object answer.
	self calculateExtraMorphs.
	internalCount _ 1.
	self startStepping
! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/20/1998 01:55'!
stopWorking

	self stopStepping.
	internalCount _ nil! !

!SturmPlotterMorph methodsFor: 'Private' stamp: 'SqR!!!! 9/19/1998 20:26'!
updateContents
	"Overriden"

	self changed! !

!SturmPlotterMorph methodsFor: 'Private - Layout' stamp: 'SqR!!!! 9/27/1998 01:45'!
bottomRightExtra
	"Answer the extra space at the bottom right corner
	of the image"

	^(fR extent x max: intB extent x) @ intB extent y! !

!SturmPlotterMorph methodsFor: 'Private - Layout' stamp: 'SqR!!!! 9/27/1998 01:04'!
calculateExtent
	"Answer the extent of the receiver"

	^self imageOffset + image extent + self bottomRightExtra! !

!SturmPlotterMorph methodsFor: 'Private - Layout' stamp: 'SqR!!!! 9/27/1998 01:44'!
imageOffset
	"Answer how much to offset the image"

	^(fZero extent x max: intA extent x) @ fZero extent y! !


!SturmPlotterMorph class reorganize!
('Instance creation' new on:)
!


!SturmPlotterMorph class methodsFor: 'Instance creation' stamp: 'SqR!!!! 9/20/1998 19:51'!
new
	"Answer a new blablabla"

	^super new initialize! !

!SturmPlotterMorph class methodsFor: 'Instance creation' stamp: 'SqR!!!! 9/20/1998 19:51'!
on: anObject
	"Answer a new instance of the receiver so
	that it wraps anObject"

	^super new initialize: anObject! !


!SturmPolyMax reorganize!
('Accessing' polynomial)
('Querying' appxBoundsIn: appxFPBoundsIn: appxFPLocal appxFPLocalValues appxLocal appxLocalValues localMaxAmount localMaxIntervals refine:upTo: refineInterval: refineIntervals refineUpTo:)
('Private' initialize:)
!


!SturmPolyMax methodsFor: 'Accessing' stamp: 'SqR!!!! 8/20/1998 01:30'!
polynomial
	"Answer the polynomial the
	receiver is tracing"

	^poly! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 9/12/1998 00:07'!
appxBoundsIn: anInterval
	"Answer anInterval that approximates
	the bounds of the polynomial the
	receiver is tracing in anInterval"

	| min max locals |

	locals _ self appxLocalValues asOrderedCollection.
	locals add: (poly valueAtScalar: anInterval start).
	locals add: (poly valueAtScalar: anInterval stop).
	min _ locals at: 1. max _ locals at: 1.
	locals do:
		[:each |
			each < min 
				ifTrue: [min _ each]
				ifFalse: [each > max ifTrue: [max _ each]]
		].
	^NumberInterval from: min to: max! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 9/12/1998 00:08'!
appxFPBoundsIn: anInterval
	"Answer anInterval that approximates
	the bounds of the polynomial the
	receiver is tracing in anInterval.
	Use floating point"

	| min max locals |

	locals _ self appxFPLocalValues asOrderedCollection.
	locals add: (poly valueAtScalar: anInterval start) asFloat.
	locals add: (poly valueAtScalar: anInterval stop) asFloat.
	min _ locals at: 1. max _ locals at: 1.
	locals do:
		[:each |
			each < min 
				ifTrue: [min _ each]
				ifFalse: [each > max ifTrue: [max _ each]]
		].
	^NumberInterval from: min to: max! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:44'!
appxFPLocal
	"Answer the approximate local maxs/mins
	of the polynomial the receiver is tracing.
	Answer floating point approximations"

	^self appxLocal collect: [:each | each asFloat]! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:43'!
appxFPLocalValues
	"Answer the approximate values of local maxs/mins
	of the polynomial the receiver is tracing. Answer 
	floating point approximations"

	^self appxLocal collect: [:each | (poly valueAtScalar: each) asFloat]! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:42'!
appxLocal
	"Answer the approximate local maxs/mins
	of the polynomial the receiver is tracing"

	^rootFinder appxRoots! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:43'!
appxLocalValues
	"Answer the approximate values of local maxs/mins
	of the polynomial the receiver is tracing"

	^self appxLocal collect: [:each | poly valueAtScalar: each]! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:32'!
localMaxAmount
	"Answer the amount of local maxs/mins of the polynomial,
	that is, the amount of places where the derivative
	becomes zero"

	^self localMaxIntervals size! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:32'!
localMaxIntervals
	"Answer the intervals where the
	polynomial the receiver is tracing
	has local maxs/mins. Maybe empty"

	^rootFinder rootIntervals! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 9/12/1998 01:44'!
refine: anInteger upTo: delta
	"Refine the anIntegerth interval where the polynomial
	the receiver is tracing has local maxs/mins, until the
	error is less than delta"

	rootFinder refine: anInteger upTo: delta! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 9/12/1998 01:44'!
refineInterval: anInteger
	"Refine the anIntegerth interval where the polynomial
	the receiver is tracing has local maxs/mins"

	rootFinder refineInterval: anInteger! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 8/20/1998 01:32'!
refineIntervals
	"Refine the intervals where the polynomial
	the receiver is tracing has local maxs/mins"

	rootFinder refineIntervals! !

!SturmPolyMax methodsFor: 'Querying' stamp: 'SqR!!!! 9/12/1998 01:45'!
refineUpTo: delta
	"Refine the intervals where the polynomial
	the receiver is tracing has local maxs/mins,
	until the error is less than delta"

	rootFinder refineUpTo: delta! !

!SturmPolyMax methodsFor: 'Private' stamp: 'SqR!!!! 8/20/1998 01:29'!
initialize: anSVPoly
	"Initialize the blah, blah and more blah!!"

	poly _ anSVPoly.
	rootFinder _ SturmRootFinder new: anSVPoly derivative.
	rootFinder isolateRoots! !


!SturmPolyMax class reorganize!
('Instance creation' new:)
!


!SturmPolyMax class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/20/1998 01:19'!
new: anSVPoly
	"Answer a new instance of the receiver"

	^super new initialize: anSVPoly! !


!SturmRootFinder reorganize!
('Accessing' chain polynomial)
('Querying' appxFPRoots appxRoots isolateRoots refine:upTo: refineInterval: refineIntervals refineUpTo: rootIntervals rootsIn:)
('Private' initialize: newRootIntervals)
!


!SturmRootFinder methodsFor: 'Accessing' stamp: 'SqR!!!! 8/17/1998 03:11'!
chain
	"Answer the sturm chain
	of the receiver"

	^chain! !

!SturmRootFinder methodsFor: 'Accessing' stamp: 'SqR!!!! 8/17/1998 03:11'!
polynomial
	"Answer the polynomial the
	receiver is working on"

	^poly! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 14:54'!
appxFPRoots
	"Answer floating point approximations to the roots
	of the polynomial of the receiver"

	^(self appxRoots collect: [:each | each asFloat]) asSortedCollection! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 03:09'!
appxRoots
	"Answer approximations to the roots
	of the polynomial of the receiver"

	^(rootIntervals collect: [:each | each center]) 
		asSortedCollection! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 18:33'!
isolateRoots
	"Shrink and partition the root intervals so that
	every of them has exactly one root"

	| toCheck newIntervals currentIndex rootsInCurrent |

	newIntervals _ self newRootIntervals.
	toCheck _ OrderedCollection withAll: rootIntervals.
	[toCheck isEmpty] whileFalse:
		[
			currentIndex _ toCheck size.
			rootsInCurrent _ self rootsIn: (toCheck at: currentIndex).
			rootsInCurrent = 1
				ifTrue: [newIntervals add: (toCheck at: currentIndex)]
				ifFalse: [rootsInCurrent = 0 ifFalse: [toCheck addAll: ((toCheck at: currentIndex) disect: 2)]].
			toCheck removeAt: currentIndex
		].
	^rootIntervals _ newIntervals! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 03:07'!
refine: anInteger upTo: delta
	"Refine the anIntegerth interval so that its
	size is less than or equal to delta"

	[(rootIntervals at: anInteger) size < delta] 
		whileFalse: [self refineInterval: anInteger]! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 02:38'!
refineInterval: anInteger
	"Refine the anIntegerth interval"

	| toCheck |

	toCheck _ (rootIntervals at: anInteger) disect: 2.
	rootIntervals removeAt: anInteger.
	(self rootsIn: (toCheck at: 1)) = 1
		ifTrue: [rootIntervals add: (toCheck at: 1)]
		ifFalse: [rootIntervals add: (toCheck at: 2)]! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 02:38'!
refineIntervals
	"Refine all the intervals of the receiver"

	1 to: rootIntervals size do:
		[:each | self refineInterval: each]! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 03:05'!
refineUpTo: delta
	"Refine all intervals so that their
	size is less than or equal to delta"

	1 to: rootIntervals size do:
		[:each | self refine: each upTo: delta]! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/16/1998 16:47'!
rootIntervals
	^rootIntervals! !

!SturmRootFinder methodsFor: 'Querying' stamp: 'SqR!!!! 8/17/1998 02:15'!
rootsIn: anOpenClosedInterval
	"Answer the amount of roots
	of the polynomial of the receiver
	in anOpenClosedInterval"

	^chain signChangeBetween: anOpenClosedInterval start
		and: anOpenClosedInterval stop! !

!SturmRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/17/1998 14:45'!
initialize: anSVPoly
	"Blah!!"

	| interval |

	poly _ anSVPoly fractionShotgun extractContents.
	chain _ SturmChain new: anSVPoly.
	chain fractionShotgun extractContents.
	rootIntervals _ self newRootIntervals.
	interval _ anSVPoly rootBounds asOpenClosed.
	interval addWidth: 1; addWidthToIntegerBounds.
	rootIntervals add: interval! !

!SturmRootFinder methodsFor: 'Private' stamp: 'SqR!!!! 8/16/1998 18:03'!
newRootIntervals
	"Answer a new root interval collection"

	^SortedCollection sortBlock: [:one :another | one start < another start]! !


!SturmRootFinder class reorganize!
('Instance creation' new:)
!


!SturmRootFinder class methodsFor: 'Instance creation' stamp: 'SqR!!!! 8/15/1998 17:06'!
new: anSVPoly
	"Answer a new instance of the receiver"

	^super new initialize: anSVPoly! !


!Symbol methodsFor: 'converting' stamp: 'SqR!!!! 8/10/1998 19:30'!
asPowerLiteral
	"Answer the receiver as a literal"

	^PowerLiteral fromSymbol: self! !


!Tuple reorganize!
('Accessing' at: at:put: dim)
('Converting' asCol asLinearEquation asLinearForm asRow asSVPoly)
('Null and identity' scalarIdentity scalarZero)
('Operating' * + , - / = dot: isMulOf: negated transposed)
('Printing' printOn:)
('Testing' hash isColumn isRow norm normSquared)
('Private' contents contents: copyNil initialize:scalarAmbient: scalarAmbient scalarAmbient:)
!


!Tuple methodsFor: 'Accessing'!
at: anInteger
	"Answer the anIntegerth coordinate of the receiver"

	^self contents at: anInteger! !

!Tuple methodsFor: 'Accessing'!
at: anInteger put: anObject
	"Set the anIntegerth coordinate of the receiver to anObject"

	^self contents at: anInteger put: anObject! !

!Tuple methodsFor: 'Accessing'!
dim
	"Answer the dimension of the receiver"

	^self contents size! !

!Tuple methodsFor: 'Converting' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:45'!
asCol
	"Convert the receiver into a column tuple"

	^ColumnTuple with: self contents! !

!Tuple methodsFor: 'Converting' stamp: 'SqR!!!!!!!! 7/20/1998 00:03'!
asLinearEquation
	"Answer the receiver as a linear equation"

	^LinearEquation 
		fromTuple: (Tuple with: (self contents copyFrom: 1 to: self dim - 1) scalarAmbient: scalarAmbient) 
		equalsTo: (self at: self dim)! !

!Tuple methodsFor: 'Converting' stamp: 'SqR!!!!!!!! 7/19/1998 23:38'!
asLinearForm
	"Convert the receiver into a LinearForm"

	^LinearForm new: self! !

!Tuple methodsFor: 'Converting' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:45'!
asRow
	"Convert the receiver into a row tuple"

	^RowTuple with: self contents! !

!Tuple methodsFor: 'Converting' stamp: 'SqR!!!! 8/9/1998 16:20'!
asSVPoly
	"Blah, you know!!"

	| x answer power |

	x _ SVPolynomial xBy: self scalarIdentity.
	answer _ SVPolynomial xBy: self scalarZero.
	power _ self scalarIdentity asMonomial.
	1 to: self dim do:
		[:each | answer _ power * (self at: each) asMonomial + answer. power _ x * power].
	^answer! !

!Tuple methodsFor: 'Null and identity' stamp: 'SqR!!!! 8/9/1998 16:18'!
scalarIdentity
	"Answer the identity for the receiver"

	^self scalarAmbient identity! !

!Tuple methodsFor: 'Null and identity' stamp: 'SqR!!!! 8/9/1998 16:18'!
scalarZero
	"Answer the null coefficient for the receiver"

	^self scalarAmbient zero! !

!Tuple methodsFor: 'Operating'!
* aNumber
	"Answer the receiver multiplied by aNumber"

	^self copy contents: (self contents collect: [:each | each * aNumber])! !

!Tuple methodsFor: 'Operating'!
+ aTuple
	"Answer the receiver plus aTuple"

	| answer |

	answer := self copyNil.
	1 to: self dim do: [:each | answer at: each put: (self at: each) + (aTuple at: each)].
	^answer
		! !

!Tuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:15'!
, aNumber
	"Answer the receiver with aNumber added at the end"

	^self copy initialize: (self contents copyWith: aNumber) scalarAmbient: self scalarAmbient ! !

!Tuple methodsFor: 'Operating'!
- aTuple
	"Answer the receiver minus aTuple"

	^self + aTuple negated! !

!Tuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:50'!
/ aNumber
	"Answer the receiver divided by aNumber"

	^self * aNumber reciprocal! !

!Tuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!! 7/21/1998 04:01'!
= aTuple
	"Answer true if the receiver is equal to aTuple"

	1 to: self dim do: [:each | (self at: each) = (aTuple at: each) ifFalse: [^false]].
	^true! !

!Tuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!! 7/19/1998 23:42'!
dot: aTuple
	"Answer the dot product between the receiver and aTuple"

	| answer |

	self contents with: aTuple contents do: 
		[:each :another | 
			answer == nil 
				ifTrue: [answer _ each * another]
				ifFalse: [answer _ each * another + answer]
		].
	^answer! !

!Tuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!! 7/21/1998 04:04'!
isMulOf: aTuple
	"Answer true if the receiver is a multiple of aTuple"

	| index |

	index _ self detect: [:one | one ~= scalarAmbient zero] ifNone: [^true].
	^self * ((aTuple at: index) / (self at: index)) = aTuple! !

!Tuple methodsFor: 'Operating'!
negated
	"Answer the receiver negated"

	^self copy contents: (self contents collect: [:each | each negated])! !

!Tuple methodsFor: 'Operating' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 15:46'!
transposed
	"Answer the transposed of the receiver"

	^self subclassResponsibility! !

!Tuple methodsFor: 'Printing' stamp: 'SqR!!!!!!!! 7/19/1998 23:36'!
printOn: aStream
	"Append the representation of the receiver into aStream"

	aStream "nextPutAll: self class name;" nextPut: $(.
	self contents
		do: [:each | each printOn: aStream]
		andBetweenDo: [aStream nextPutAll: ', '].
	aStream nextPut: $)! !

!Tuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!! 7/21/1998 04:01'!
hash
	"Answer the hash of the receiver"

	^contents hash! !

!Tuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:17'!
isColumn
	"Answer true if the receiver is a column tuple"

	^self subclassResponsibility! !

!Tuple methodsFor: 'Testing' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:17'!
isRow
	"Answer true if the receiver is a row tuple"

	^self subclassResponsibility! !

!Tuple methodsFor: 'Testing'!
norm
	"Answer the norm of the receiver"

	^self normSquared sqrt! !

!Tuple methodsFor: 'Testing'!
normSquared
	"Answer the norm squared of the receiver"

	^self dot: self! !

!Tuple methodsFor: 'Private'!
contents
	"Private - Answer the contents of the receiver"

	^contents! !

!Tuple methodsFor: 'Private'!
contents: anObject
	"Private - Set the contents of the receiver to anObject"

	contents := anObject! !

!Tuple methodsFor: 'Private' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:12'!
copyNil
	"Private - Answer a copy of the receiver with contents with nil values"

	^self copy initialize: (Array new: self dim) scalarAmbient: self scalarAmbient! !

!Tuple methodsFor: 'Private' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:13'!
initialize: anIndexedCollection scalarAmbient: aScalarAmbient
	"Private - Initialize the receiver"

	self 
		contents: anIndexedCollection asArray;
		scalarAmbient: aScalarAmbient
! !

!Tuple methodsFor: 'Private' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:12'!
scalarAmbient
	^scalarAmbient! !

!Tuple methodsFor: 'Private' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:12'!
scalarAmbient: aScalarAmbient
	scalarAmbient := aScalarAmbient! !


!Tuple class reorganize!
('Default scalar ambient' defaultScalarAmbient defaultScalarAmbient:)
('Instance creation' eSub: eSub:scalarAmbient: nullDim: nullDim:scalarAmbient: with: with:scalarAmbient:)
!


!Tuple class methodsFor: 'Default scalar ambient' stamp: 'SqR!!!!!!!! 7/19/1998 23:56'!
defaultScalarAmbient
	"Answer the default scalar ambient"
	
	DefaultScalarAmbient isNil ifTrue: [DefaultScalarAmbient _ ScalarAmbientRationals new].
	^DefaultScalarAmbient! !

!Tuple class methodsFor: 'Default scalar ambient' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:21'!
defaultScalarAmbient: aScalarAmbient
	"Set the default scalar ambient to aScalarAmbient"
	
	DefaultScalarAmbient := aScalarAmbient! !

!Tuple class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:31'!
eSub: aPoint
	"Answer the aPoint xth canonical tuple of dimension aPoint y"

	^self eSub: aPoint ambient: self defaultScalarAmbient! !

!Tuple class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:33'!
eSub: aPoint scalarAmbient: aScalarAmbient
	"Answer the aPoint xth canonical tuple of dimension aPoint y.
	Take the scalar zero and identity from aScalarAmbient"

	| contents |

	contents := Array new: aPoint y.
	contents atAllPut: aScalarAmbient zero.
	contents at: aPoint x put: aScalarAmbient identity.
	^self with: contents scalarAmbient: aScalarAmbient! !

!Tuple class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!! 7/21/1998 03:55'!
nullDim: anInteger
	"Answer the null tuple of dimension anInteger.
	Use the default scalar ambient"

	| contents |

	contents _ Array new: anInteger.
	contents atAllPut: self defaultScalarAmbient zero.
	^self with: contents scalarAmbient: self defaultScalarAmbient! !

!Tuple class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!! 7/21/1998 03:55'!
nullDim: anInteger scalarAmbient: aScalarAmbient
	"Answer the null tuple of dimension anInteger
	and of scalar ambient aScalarAmbient"

	| contents |

	contents _ Array new: anInteger.
	contents atAllPut: aScalarAmbient zero.
	^self with: contents scalarAmbient: aScalarAmbient! !

!Tuple class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:23'!
with: anIndexedCollection
	"Answer a new instance of the receiver with its coordinates taken from anIndexedCollection"

	^super new initialize: anIndexedCollection scalarAmbient: self defaultScalarAmbient! !

!Tuple class methodsFor: 'Instance creation' stamp: 'SqR!!!!!!!!!!!!!!!! 4/16/98 16:33'!
with: anIndexedCollection scalarAmbient: aScalarAmbient
	"Answer a new instance of the receiver with its coordinates taken from anIndexedCollection"

	^super new initialize: anIndexedCollection scalarAmbient: aScalarAmbient! !


GaussianRootFinder removeSelector: #fastOutDetermination!
GaussianRootFinder removeSelector: #xMinusALot:!
SturmChain removeSelector: #signChangesBetween:and:!
SturmPlotter removeSelector: #plotWidth!
SturmPlotter removeSelector: #partialAnswer!
SturmPlotter removeSelector: #plotWitdth!
SturmPlotter removeSelector: #plotDimension:!
SturmPlotter removeSelector: #polyHeight!
SturmPlotter removeSelector: #plotWidth:!
SturmPlotter removeSelector: #deltaX!
SturmPlotter removeSelector: #polyHeight:!
SturmPlotter removeSelector: #deltaX:!
SturmPlotter removeSelector: #polyMaxes:!
SturmPlotter removeSelector: #plotDimension!
SturmPlotter removeSelector: #generateColorPalletes!
SturmPlotter removeSelector: #polyMaxes!
SturmPlotterMorph removeSelector: #wantsStep!
SturmPlotterMorph removeSelector: #imageBoxing!
SturmPlotterMorph removeSelector: #debug!
SturmPolyMax removeSelector: #appxBounds!
SturmPolyMax removeSelector: #refine:!
SturmPolyMax removeSelector: #refineInterval:upTo:!
SturmPolyMax removeSelector: #refineIntervalsUpTo:!
SturmPolyMax removeSelector: #appxFPBounds!
SturmRootFinder removeSelector: #refine:UpTo:!
SturmRootFinder removeSelector: #rootBounds!
Tuple removeSelector: #zero!
